         real function dguass(A,X)
         implicit none
         real A(*),x,dGaussGen
         external dGaussGen
         dguass=A(1)*dGaussGen(A,X)+A(4)
         
         end



c dyamic K-T function
c based on code for:
c	Dynamic f-u-f relaxation function
c	from Brewer et al, Hyperf. Int. 32 (1986) pp677-682
	real function dGaussGen(A,t)
	implicit none
	real t,sig,nu
C
	integer tsmax,stk
	parameter (tsmax=4000) ! 16 us of valid data
	parameter (stk=25)
	double precision eps
	parameter (eps=0.008) ! "bin" for calculations
	integer k,j,sp,ls
	double precision gs(tsmax),gd(tsmax,stk)
	double precision y,tt,hop
	real xe,oldsig(stk),oldnu(stk)
	integer xi
	real A(*)
	data ls /0/, oldsig /stk * -999.0/ 

c	save /gd/,/olda2/,/olda3/,/ls/
	
	sig=A(2)
	nu=A(3)

	do 5 sp=1,stk
	  if( sig .eq. oldsig(sp) .and. nu .eq. oldnu(sp)) goto 66
5	continue

	ls=ls+1
	if (ls .gt. stk .or. ls .lt. 1) then
	  ls=1
	endif
	sp=ls

	oldsig(ls)=sig
	oldnu(ls)=nu

	hop=nu*eps


c generate static Kubo-Toyabe
	do 10 k=1,tsmax
	  tt=((k-1)*eps*sig)**2
	  gs(k)=0.3333333333+0.6666666667*exp(-tt/2)
10	continue
	

c generate dynamic f-u-f
	  do 30 k=1,tsmax
	    y=gs(k)
	    do 40 j=k-1,2,-1
	      y=y*(1-hop)+hop*gd(k-j+1,ls)*gs(j)
40	    continue
	    gd(k,ls)=y
30	  continue

66	continue

c interpolate table. If beyond end, extrapolate...
	XI=int(abs(t)/eps)
	if(xi .gt. tsmax-2) xi=tsmax-2
	xe=abs(t)/eps-xi
	
	dGaussGen=(gd(xi+1,sp)*(1-xe)+xe*gd(xi+2,sp))
	return
	end

