C
C Compile in OPENGENIE module/compile "convert_Ascii.for" comp_flags="
C /check=all" symbols="convert_ascii"
C

      subroutine convert_ascii(pars_in,pars_out)
      implicit none
        
      external pars_in,pars_out
      integer dtflag,nhisto,histlen,rdata(80,64000),frames
	integer nfgroups, nhg(2,8), ndt, hists(2,128,8)
	integer tempdata(1280000),i,j,res_len,tres,grouping(512)
	integer group(512)
	integer nhistarr(16)
	real t0,ratl(64000,8),rate(64000,8),res_pscnds,deadt(128)
	integer outputtype,temparr(2), arraysize
	real tim(64000),alpha(8),temp(64000),tempe(64000),alp
	real cordata(80,64000)
	logical rgmode
! If array size changes for detectors then change this number to
        arraysize=80
       	
      call module_get_int(pars_in,'dt',dtflag)
	call module_get_int(pars_in,'histolen',histlen)
	call module_get_int(pars_in,'nhisto',nhisto)
      call module_get_real(pars_in,'t0',t0)
	call module_get_int(pars_in,'frames',frames)
	call module_get_int(pars_in,'tres',tres)
	res_pscnds=real(tres)
	


	call module_get_real_array(pars_in,'deadt',deadt,nhisto)	
      call module_get_int_array
     +              (pars_in,'counts',tempdata,histlen*nhisto)
	do i=1,nhisto
	 do j=1,histlen
	   rdata(i,j)=tempdata((i-1)*histlen+j)
	 enddo
	enddo
      
	call module_get_int(pars_in,'ndt',ndt)
	call module_get_int(pars_in,'format',outputtype)
	
	if (outputtype.eq.1) then
        call main_histo(rdata,histlen,dtflag,tim,res_pscnds,frames,
     +                      t0, nhisto,cordata,deadt)
 	  call module_put_real_array
     +                      (pars_out,"time",tim,histlen)

	  temparr(1)=arraysize
	  temparr(2)=histlen
	  call module_put_nd_real_array(
     +    pars_out,"cordata",cordata,temparr,2)
	  
	elseif (outputtype.eq.2) then
        call module_get_int(pars_in,'nfgroups',nfgroups)
	  if (nfgroups.eq.1) then
	    rgmode=.false.
	  else
	    rgmode=.true.
	  endif
        call module_get_real(pars_in,'alpha',alp)
	  alpha(1)=alp
        call module_get_int_array(pars_in,'grouping',grouping,ndt)
	  call module_get_int_array(pars_in,'group',group,ndt)
        do i=1,16
	    nhistarr(i)=0
	  enddo
	  do i=1,ndt
	    nhistarr(grouping(i))=nhistarr(grouping(i))+1
          hists(grouping(i),nhistarr(grouping(i)),nfgroups)=group(i)
	  enddo
  	  do j=1,8
 	   do i=1,2
	    nhg(i,j)=nhistarr(i)
	   enddo
	  enddo
        call main_asym(nfgroups,histlen,nhg,hists,ndt,res_pscnds,rgmode
     +   ,deadt,frames,rdata,t0,rate,ratl,dtflag,tim,alpha,res_len)
  	  do i = 1, res_len
	   temp(i)=ratl(i,1)
  	   tempe(i)=rate(i,1)
	  enddo

         call module_put_real_array
     +                      (pars_out,"asym",temp,res_len)
         call module_put_real_array
     +                      (pars_out,"error",tempe,res_len)
         call module_put_real_array
     +                      (pars_out,"time",tim,res_len)

	   call module_put_nd_real_array
     +               (pars_out,"ratl",ratl,res_len,nfgroups)
      endif

       	
       	
       end


      subroutine main_asym(nfgroups,histlen,nhg,hists,ndt,res_pscnds,
     +rgmode,deadt,frames,rdata,t0,rate,ratl,dtflag,tim,alpha,res_len)
	implicit none

      integer nfgroups, histlen, nhg(2,8), ndt,frames
	integer rdata(80,64000), hists(2,128,8),dtflag
	real res_pscnds,t0,deadt(128),alp
	real alpha(8)
	logical rgmode

	integer gp,fb,ic,i,ig,igd
	real gsum(2,64000,8),ress, cordat,ee,er2, fsum,bsum,lnum,rat,lden
	real tim(64000),cor

      real ratl(64000,8),rate(64000,8)
	integer res_len

c +++++++++ asymmetry ++++++++++++
c (from RUMDA)
c T0 from basetime.uda file
c Groups from long.uda? fixed?
c Alpha from user (suggest value from long.uda)
c Dead time from dtpar.dat / dtepar.dat
	do gp=1,nfgroups ! groups in file
	 do fb=1,2 ! forward then backward set
c        write(15,*) fb
	  do ic=1,histlen
	    gsum(fb,ic,gp)=0.
	  enddo

	  do i=1,nhg(fb,gp) ! histos within grp
          ig=hists(fb,i,gp)
	write(98,*) 'ig',ig 
	    igd=ig
	    if(ig .gt. ndt .and. rgmode) then
	     igd=igd-ndt
	    endif
c
c correct counts and group histograms
c
	    ress=real(res_pscnds)/1000000
          do ic=1,histlen
           if (dtflag.eq.1 .and. deadt(igd) .gt.0) then
	       cor=1.0-deadt(igd)*float(rdata(ig,ic))/(float(frames)*ress)
             cordat=float(rdata(ig,ic))/cor
	      else
	       cordat=rdata(ig,ic)
	     endif

           gsum(fb,ic,gp)=gsum(fb,ic,gp)+cordat
	    enddo
        enddo
	 enddo
	enddo
      do ic=1,histlen
       tim(ic)=((ic-0.5)*ress)-t0
      enddo
      res_len=0
      do ic=1,histlen
        if(tim(ic).ge.0) then
	    res_len=res_len+1
	    do gp=1,nfgroups
            fsum=gsum(1,ic,gp)
            bsum=gsum(2,ic,gp)
            lnum=(fsum-alpha(gp)*bsum)
            lden=(fsum+alpha(gp)*bsum)
	      if(lden .gt.0) then
              rat=lnum/lden
              ee=(fsum+alpha(gp)*alpha(gp)*bsum)
              er2=ee*(1/(lden*lden))*(1 + rat*rat)
	        ratl(ic,gp)=rat
              rate(ic,gp)=sqrt(er2)
	      else ! no counts in F or B
	        ratl(ic,gp)=0.0
	        rate(ic,gp)=99.9 ! arbitrary?
	      endif
	
	    enddo
	  endif
      enddo
c

	end

      subroutine main_histo(rdata,histlen,dtflag,tim,res_pscnds,frames,
     +                      t0, nhisto,cordata,deadt)
	 implicit none

      integer histlen,frames, nhisto
	integer rdata(80,2048), hists(2,128,8),dtflag

	integer ic, igd
	real ress,t0, cordat, cor, res_pscnds
      real tim(64000),deadt(128), cordata(80,2048)

      ress=real(res_pscnds)/1000000
      do ic=1,histlen
       tim(ic)=((ic-0.5)*ress)-t0
      enddo
	do igd=1,nhisto
        do ic=1,histlen
	    cordata(igd,ic)=0.0
          if (dtflag.eq.1 .and. deadt(igd) .gt.0) then
	      cor=1.0-deadt(igd)*float(rdata(igd,ic))/(float(frames)*ress)
            cordat=float(rdata(igd,ic))/cor
	    else
	      cordat=rdata(igd,ic)
	    endif
	    cordata(igd,ic)=cordat
        enddo
	enddo

	end
