c	CONVERT_ASCII_4
c Oct-Nov 1997 J.S.Lord Added new formats, dead time correction etc.
c
c Nov 2004 S.P. Cottrell added NeXus support
c
c Dec 2004 Aidy added Rumda output

	options /extend_source
	program convert_ascii_3
	implicit none

	include 'muon_def.inc'

	integer llen
c some useful local variables
	integer i,j,k,l,nhis,frames,dig
	integer ie,tcounts,sum,il,id
	character line*80
	character end_char
	character*3 beamline, get_beamline, prefix
        character*4 lprefix
	character*20 iname
	character*20 temp,field
	character*40 setup, data_path, raw_path, aux_path
	character*62 comment
	integer ic,ih,ig,igd,current,first_file,last_file,files_done
	integer readgroup,grouprep
	real ress,t,cor,cordat
	integer ic1,ic2,gp,nfgroups
	integer max,nsf
	integer fform,cdir_ok

	real t0,alpha(8),deadt(128)
	real junk
	integer ndt,dtflag
	character*80 dtfile,dtsource
	integer fb
	real fsum,bsum,lnum,lden,rat,ee,er2
	real ratl(8000,8),rate(8000,8)

	integer nhg(2,8),hists(2,128,8) ! list of histograms for each group
	real gsum(2,8000,8) ! grouped data
	real tim(8000)

	character*10 grpname(10)
	character*10 orient

	real taverage,tmin,tmax,trms
	character*80 tname
	logical want_tlog,t_ok,nxexists, want_rumda
	integer status,NXMread

	integer*2 ib(512)
c debug
	byte ibb(512)
	equivalence(ibb(1),ib(1))
c debug
c info-block data is mapped to variables with equivalence
	integer rdata(80,2048)
	integer*2 istfla,rescod,nrun,numhis,histlen,numrec,lenrec
	integer*2 t0bin(32),tgood_begin(32),tgood_end(32)
	integer*2 ngroups,branch(4),crate(4),first(4),ndev(4)
	integer*4 res_pscnds,ntotal(32)
	character rtitle*40, devtyp(4)*4
	character*9 start_date,stop_date
	character*8 start_time,stop_time
	character*80 fname
	character*18 date
c the last ones are not tested yet
c grouping should be the file name of a grouping table (hopefully UDA format)
c the frames stuff should be at ib(68),ib(69) but there must be some mistake
	logical*1 rgmode	! true for Red/Green mode data, the the
				! number of hists are doubled ??
	integer*2 nreads, nframes  !number of readouts, frames/readout NEWWWW
	integer*4 nreads4
	character*32 grouping  !NEWWWW
	integer*4 nrun32

	equivalence
	1 (istfla,ib(1)), (rescod,ib(2)), (res_pscnds,ib(7)),
	1 (nrun,ib(4)), (start_date,ib(110)), (stop_date,ib(115)),
	1 (start_time,ib(120)), (stop_time,ib(124)), (rtitle,ib(70)),
	1 (numhis,ib(16)), (histlen,ib(15)), (numrec,ib(65)),
	1 (lenrec,ib(66)), (t0bin(1),ib(256-3*32)),
	1 (tgood_begin(1),ib(256-2*32)), (tgood_end(1),ib(256-32)),
	1 (ntotal(1),ib(256)), (branch(1),ib(512-5*4)),
	1 (crate(1),ib(512-4*4)), (first(1),ib(512-3*4)),
	1 (ndev(1),ib(512-2*4)), (devtyp(1),ib(512-4)),
	1 (ngroups,ib(512)),(comment,ib(431)),
	1 (rgmode,ib(67)),(nreads,ib(68)),(nframes,ib(69)),   !NEWWWWWW
	1 (nrun32,ib(11))
c	All path names must end with this character
	parameter (end_char = ']')

c
c discover beamline on which data was taken
c
	beamline = get_beamline()
c set details of each beamline
c ALTER THESE IF THINGS CHANGE !
c data_path (Rnnnnn.RAL), raw_path,aux_path (EMUnnnnn.RAW) searched for
c data in that order followed by current directory
c dtfile is the dead time correction or 'NL:' if none available
	if (beamline.eq.'EMU') then
	   data_path = 'EMU$DISK0:[DATA.EMU]'
	   raw_path = 'EMU$DISK1:[EMUMGR.DATA]'
	   aux_path = 'SCRATCH$DISK:[EMUMGR.RESTORE]'
	   prefix = 'EMU'
	   dtfile = 'EMU$DISK:[EMUMGR.EMU_USERS.RUMDA]dtepar.dat'
	   iname='EMU'
	elseif (beamline.eq.'MUS') then
c	files named 'Rnnnnn.RAL' from old and new sequences look the same
	   data_path = 'MUSR$DISK0:[DATA.MUSR.OLD.SEQ]' ! must not be found
	   raw_path = 'MUSR$DISK1:[MUMGR.DATA]'
	   aux_path = 'SCRATCH$DISK:[MUMGR.RESTORE]'
	   prefix = 'MUS'
	   dtfile = 'MUSR$DISK:[MUMGR.MUSR_USERS.RUMDA]dtpar.dat'
	   iname='MUSR (old seq)'
	elseif (beamline.eq.'USR') then
	   data_path = 'MUSR$DISK0:[DATA.MUSR]'
	   raw_path = 'MUSR$DISK1:[MUMGR.DATA]'
	   aux_path = 'SCRATCH$DISK:[MUMGR.RESTORE]'
	   prefix = 'USR'
	   dtfile = 'MUSR$DISK:[MUMGR.MUSR_USERS.RUMDA]dtpar.dat'
	   iname='MUSR'
	elseif (beamline.eq.'MU2') then
	   data_path = 'MUSR$DISK0:[DATA.MUSR]'
	   raw_path = 'MUSR$DISK1:[MUMGR.DATA]'
	   aux_path = 'SCRATCH$DISK:[MUMGR.RESTORE]'
	   lprefix = 'MUSR'
	   dtfile = 'MUSR$DISK:[MUMGR.MUSR_USERS.RUMDA]dtpar.dat'
	   iname='MUSR (DAE2)'
	elseif (beamline.eq.'ARG') then
	   data_path = '19.39::sys$sysdevice:[DATA.RIKMS3]'
	   raw_path = 'MUSR$DISK:[MUMGR.DATA]'
	   aux_path = 'SCRATCH$DISK:[MUMGR.RESTORE]'
	   prefix = 'ARG'
	   dtfile = 'NL:'
	   iname='ARGUS'
	elseif (beamline.eq.'MUT') then
	   data_path = 'MUT$DISK0:[DATA.MUT]'
	   raw_path = 'MUT$DISK1:[MUTMGR.DATA]'
	   aux_path = 'SCRATCH$DISK:[MUTMGR.RESTORE]'
	   prefix = 'MUT'
	   dtfile = 'MUT$DISK:[MUTMGR.MUT_USERS.RUMDA]DTMPAR.DAT'
	   iname='MUT/DEVA'
	endif

c
c find range of files to be processed
c
	type *,' '
	type *,'Enter first file to be converted'
	accept *,first_file
	type *,'Enter last file to be converted'
	accept*,last_file
	if (last_file.lt.first_file) then
		type *,'Range not allowed..!!!'
		stop
	endif
	files_done=0
c
c ask for file format
c
	type *,' '
	type *,'Format of ASCII output file:'
	type *,'1. .USR format'
	type *,'2. All histograms as columns'
	type *,'3. Asymmetry (LF/ZF only)'
        type *,'4. Rumda data file'
	write(*,166)
166	format (' Format [1] ',$)
	read(*,'(A80)')line
	fform=1
	read(line,*,err=167,end=167)fform
167	if (fform .lt.1 .or. fform .gt.4) then
	  write(*,*)'Unknown format'
	  stop
	endif
	type *,' '

	if(fform .gt.1) then
c get basetime
	  open(1,file='BASETIME.UDA',status='old',readonly,err=765)
	  read(1,'(A80)')line
	  read(1,*)t0
	  write(*,*)'T0 found in BASETIME.UDA'
	  close(1)
	  goto 766
765	  write(*,*)'BASETIME.UDA missing, suggest t0=0.22 us for MUSR,'
	  write(*,*)'0.278 for EMU, 0.517 for ARGUS'
	  t0=0.0
766	  write(*,767)t0
767	  format(' T0 [',F5.3,'] ?',$)
	  read(*,'(A80)')line
	  read(line,*,err=768,end=768)t0
768	  continue
	  type *,' '
	endif

	if(fform .gt.1) then
c get dead time
	  dtflag=0
	if(dtfile .ne. 'NL:') then
430	  write(*,431)
431	format(' Dead time correction (RUMDA method)? [Y] ',$)
	  read(*,'(A80)')line
	  if(line(1:1) .eq. 'Y' .or. line(1:1) .eq. 'y'
     +      .or. llen(line) .eq.0) then
            open(1,file=dtfile,status='old',readonly,err=436)
	    read(1,*)ndt
	    do 432 i=1,ndt
	      read(1,*)j,deadt(i)
	      if (deadt(i) .le. 0.0) deadt(i)=0.0
432	    continue
	    read(1,'(A80)',err=433,end=433)dtsource
	    write(*,*)'Dead times read from file ',dtsource(1:40)
	    dtflag=1
	    close(1)
	    goto 439
433	    write(*,*)'Dead times read in'
	    dtsource=dtfile
	    dtflag=1
	    close(1)
	    goto 439
436	    write(*,*)'No dead time values available'
	    write(*,4361)
4361	    format (' Continue anyway with uncorrected data? [y] ',$)
	    read(*,'(A80)')line
	    if(line(1:1) .ne.'Y' .and. line(1:1).ne.'y'
     *		.and.line .ne.' ') then
	      stop
	    endif
439	    continue
	  else if(line(1:1) .ne. 'N' .and. line(1:1) .ne. 'n') then
	    goto 430
	  endif
	  type *,' '
	else
	  type *,'No dead time calibration available for '//iname
	  type *,' '
        endif
	endif

	if(fform .eq.3.or.fform.eq.4) then
	    orient='LONG'
	    write(*,*)'Grouping file [LONG] ?'
	    read(*,'(A10)')orient
	    if(orient(1:1).eq.' ') then
	      orient='LONG'
	    endif
c get grouping and alpha
	  open(1,file=orient//'.uda',status='old',readonly,err=876)
	  read(1,'(A80)')line ! header
	  read(1,*)i ! num hists
	  do 441 j=1,i
	    read(1,'(A80)')line ! hist name
	    read(1,*)junk
441	  continue
	  read(1,*)i ! grp type
	  read(1,*)i ! bunching
	  read(1,*)nfgroups ! num of groups
c read the groups
	  do 442 k=1,nfgroups
	  read(1,*) grpname(k) ! name
	  read(1,*)nhg(1,k)
	  read(1,*)(hists(1,j,k),j=1,nhg(1,k))
	  read(1,*)nhg(2,k)
	  read(1,*)(hists(2,j,k),j=1,nhg(2,k))
	  read(1,*)alpha(k)
442	  continue
	  close(1)
	  goto 4410
876	  type *,'Grouping file '//orient//'.UDA missing'
	  type *,'Type SETUP or run UDA to create one'
	  stop
c could enter grouping by hand here?

4410	  write(*,*)'Grouping and Alpha read from '
     *		//orient//'.UDA'
	do 4449 k=1,nfgroups
	  write(*,*)'Group: ',grpname(k)
	  write(*,444)'Forward histograms:',(hists(1,j,k),j=1,nhg(1,k))
	  write(*,444)'Backward histograms:',(hists(2,j,k),j=1,nhg(2,k))
444	format (A21,16(' ',I2))

	  write(*,445)alpha(k)
445	format (' Alpha [',F7.4,'] ?',$)
	  read(*,'(A80)')line
	  read(line,*,err=446,end=446)alpha(k)
446	  continue
4449	  continue
	  type *,' '
	endif

c ask about TLOGs
	write(*,*)'Include temperature log summary in header? [n]'
	want_tlog=.FALSE.
	read(*,'(A80)')line
	if(line(1:1) .eq. 'Y' .or. line(1:1) .eq. 'y') want_tlog=.TRUE.
      

c
c *** main loop ***
c
	cdir_ok = 0
	do current=first_file,last_file

	if (iname(1:11) .eq. 'MUSR (DAE2)') then
c
c this next section of code handles nexus files from DAE2
c
           write(*,*) ' Searching for NeXus file ...'

	   write(fname,850) data_path(1:index(data_path,end_char)),
     +                      lprefix, current
           write(*,*) fname
	   inquire(file=fname,exist=nxexists)
	   if (nxexists .eq. .true.) then
              status = NXMread(fname)
	   else
              goto 750
           endif
	   GOTO 752

750	   write(fname,850) raw_path(1:index(raw_path,end_char)),
     +                      lprefix, current
           write(*,*) fname
	   inquire(file=fname,exist=nxexists)
	   if (nxexists.eq.1) then
              status = NXMread(fname)
	   else
              goto 751
           endif
	   GOTO 752

751	   write(fname,850) aux_path(1:index(aux_path,end_char)),
     +                      lprefix, current
           write(*,*) fname
	   inquire(file=fname,exist=nxexists)
	   if (nxexists.eq.1) then
              status = NXMread(fname)
	   else
              goto 7511
           endif
	   GOTO 752

c try the current directory
7511	   continue
	   write(fname,850) '[]',prefix, current
           write(*,*) fname
	   inquire(file=fname,exist=nxexists)
	   if (nxexists.eq.1) then
7529	      if(cdir_ok .eq. 0) then
	         write(*,7599)
7599	         format(' RAW file found in the current directory. Use it? [y] ',$)
	         read(*,'(A80)')line
	         if(line(1:1).eq.'N' .or.line(1:1).eq.'n')then
	            goto 900
	         endif
	         cdir_ok = 1
	      endif
              status = NXMread(fname)
	   else
              goto 900
           endif

752        write (*,*) ' '

c
c cast data returned from NXMread into format expected by CONVERT_ASCII
c
	   nrun = NXM_run_number
	   nrun32 = nrun
	   nhis = NXM_histogram_number
           rgmode = NXM_run_switching_states
           frames = NXM_beam_frames * NXM_beam_daereads
	   write (temp, '(F10.3) Kelvin') NXM_sample_temperature
           write (field, '(F10.3) Gauss') NXM_sample_magnetic_field
           rtitle = NXM_sample_name
           date = NXM_run_start_time
	   comment = NXM_run_notes
           setup = ' '
           if (NXM_detector_orientation .EQ. 'l') then
              setup = 'Longitudinal, '
           else
              setup = 'Transversal, '
           endif
           if (NXM_sample_shape.eq.'NONE') then
              setup(14:) = 'not oriented'
           else
              setup(14:) = NXM_sample_shape
           endif

           res_pscnds = NXM_histogram_resolution
           histlen = NXM_histogram_length  
	   if(numhis.gt.128.or.histlen.gt.8000) goto 940
	   do ih=1,nhis
              do i=1,histlen
	         rdata(ih,i)=NXM_histogram_counts(ih,i)
              enddo
	   enddo

	   write (*,*) date, comment

c Sum up all channels in all histograms to get 'tcounts', the total number of
c detected events for the run
c If frames=0, then assign a (dummy) value by taking tcounts/nhis
	   tcounts=0
	   do ih=1,numhis
	      do ic= 43,1500
	         if(tcounts.lt.2000000000)tcounts=tcounts+rdata(ih,ic)
	         enddo
	      enddo
	   if(frames.eq.0) then
	      frames=(tcounts/nhis+50)
	   endif

c now do temperature calculations if log exists in NeXus file
           t_ok = NXM_temp_log_available
	   if ((want_tlog).and.(t_ok)) then
	      call nxtlogger(tname,taverage,trms,tmin,tmax)
	   else
	      if (want_tlog) write(*,*)'TLOG file NOT found for run ',current
	   endif
           	
	else

c
c this next section of code handles traditional MCS type files
c

	   write(fname,800) data_path(1:index(data_path,end_char)), current
	   open(1,file=fname,status='old',form='unformatted',err=700,readonly)
c append .TLOG to end of directory if reading from FEM
	   write(tname,8800) data_path(1:index(data_path,end_char)-1) //
     *		   '.TLOG]', current

	   GOTO 702
700	   write(fname,802) raw_path(1:index(raw_path,end_char)),
     +                      prefix, current
	   open(1,file=fname,status='old',form='unformatted',err=701,readonly)
	   write(tname,8802) raw_path(1:index(raw_path,end_char)),
     +                      'R', current

	   GOTO 702
701	   write(fname,802) aux_path(1:index(aux_path,end_char)),
     +                      prefix, current
	   open(1,file=fname,status='old',form='unformatted',err=7011,readonly)
	   write(tname,8802) aux_path(1:index(aux_path,end_char)),
     +                      'R', current

	   GOTO 702
c try the current directory with each filename
7011	   continue
	   write(fname,802) '[]',prefix, current
	   open(1,file=fname,status='old',form='unformatted',err=7012,readonly)
	   write(*,*)'Run ',current,' found in the current directory'
	   write(tname,8802) '[]','R', current

	   GOTO 7029
7012	   write(fname,800) '[]', current
	   open(1,file=fname,status='old',form='unformatted',err=900,readonly)
	   write(*,*)'Run ',current,' found in the current directory'
	   write(tname,8800) '[]', current

7029	   if(cdir_ok .eq.0) then
	      write(*,7099)
7099	      format(' RAW file found in the current directory. Use it? [y] ',$)
	      read(*,'(A80)')line
	      if(line(1:1).eq.'N' .or.line(1:1).eq.'n')then
	         goto 900
	   endif
	   cdir_ok = 1
	   endif

702        continue

	   read(1,err=910,end=930) ib

	   nhis=numhis
	   if(rgmode) then
	      nhis=nhis*2
	   endif

	   nreads4=nreads	!there should be a cleaenr way of avoiding overflow
	   frames=nreads4*nframes
c run numbers (old data)
	   if(nrun32 .eq.0) nrun32=nrun

c dig out and format the temperature
c try to delete leading blanks and trailing 0's assuming f8.3 format
	   ic1=12
	   ic2=19
	   if(rtitle(12:12).eq.' ') ic1=13
	   if(rtitle(12:13).eq.'  ') ic1=14
	   if(rtitle(12:14).eq.'   ') ic1=15
	   if(rtitle(19:19).eq.'0') ic2=18
	   if(rtitle(18:19).eq.'00') ic2=17
	   if(rtitle(17:19).eq.'000') ic2=15
	   temp=rtitle(ic1:ic2)//' K'

c dig out and format the field
c try to delete leading blanks and trailing 0's assuming f2.3 format
	   ic1=21
	   ic2=28
	   if(rtitle(21:21).eq.' ') ic1=22
	   if(rtitle(21:22).eq.'  ') ic1=23
	   if(rtitle(21:23).eq.'   ') ic1=24
	   if(rtitle(21:24).eq.'    ') ic1=25
	   if(rtitle(28:28).eq.'0') ic2=27
	   if(rtitle(27:28).eq.'00') ic2=25
	   field=rtitle(ic1:ic2)//' Gauss'
	

c read histogram data (if not to large)
	   if(numhis.gt.32.or.histlen.gt.2048) goto 940
	   do ih=1,nhis
	      read(1,err=910,end=930) (rdata(ih,i),i=1,histlen)
	   enddo
	   close(1)

c now try to read the TLOG from the same place: filename in TNAME
	   if(want_tlog) then
	      call tlogger(tname,t_ok,taverage,trms,tmin,tmax)
	      if(.not.t_ok)write(*,*)'TLOG file NOT found for run ',current
	   else
	      t_ok = .FALSE.
	   endif

c Sum up all channels in all histograms to get 'tcounts', the total number of
c detected events for the run
c If frames=0, then assign a (dummy) value by taking tcounts/nhis
	   tcounts=0
	   do ih=1,numhis
	      do ic= 43,1500
	         if(tcounts.lt.2000000000)tcounts=tcounts+rdata(ih,ic)
	         enddo
	      enddo
	   if(frames.eq.0) then
	      frames=(tcounts/nhis+50)
	   endif
	   setup = ' '
	   if (rtitle(29:29).eq.'t')setup='Transversal, '
	   if (rtitle(29:29).eq.'l')setup='Longitudinal, '
	   if (rtitle(31:34).eq.'NONE') then
	      setup(14:)='not oriented'
           else
	      setup(14:)=rtitle(31:40)
	   endif
	   date=start_date//' '//start_time
	
        endif

c USRWRITE.FOR, write data to file

	if(fform .eq.1) then
c+++++++++ start here for old format +++++++++

c set the name of the file
        if (iname .eq. 'MUSR (DAE2)') then
	   write(fname,851) lprefix, current, 'USR'
        else
	   write(fname,801) prefix, current, 'USR'
	endif

800	format(a,'R',i5.5,'.RAL')
802	format(a,a,i5.5,'.RAW')
801	format(a,i5.5,'.',a)

8800	format(a,'R',i5.5,'.TLOG')
8802	format(a,a,i5.5,'.TLOG')

850	format(a,a,i8.8,'.NXS')
851	format(a,i8.8,a)

	   open(1,file=fname,status='new',carriagecontrol='list',
	1  defaultfile='usrdata.usr',err=901)
	   write(1,'(''UDALASER type data file'')',err=902)
	write(1,*,err=902)comment
	   write(1,'()',err=902)


c write magic line to start data record
	write(1,'(''Begin_uSR: RAL'')',err=902)

c write the run labels
	write(1,'(''Run: '',i<dig(nrun32)>)',err=902) nrun32
	if(llen(rtitle).gt.0) write(1,
	1 '(''Title: '',a10)',err=902) rtitle(1:10)
	if(llen(field).gt.0) write(1,
	1 '(''Field: '',a<llen(field)>)',err=902) field
	if(llen(setup).gt.0) write(1,
	1 '(''Setup: '',a<llen(setup)>)',err=902) setup
	if(llen(temp).gt.0) write(1,
	1 '(''Temp: '',a<llen(temp)>)',err=902) temp
	if(llen(date).gt.0) write(1,
	1 '(''Date: '',a<llen(date)>)',err=902) date

	if(t_ok) then
	  write(1,'(''TLOG Average: '',F9.4)',err=902) taverage
	  write(1,'(''TLOG RMS: '',F9.4)',err=902) trms
	  write(1,'(''TLOG Minimum: '',F9.4)',err=902) tmin
	  write(1,'(''TLOG Maximum: '',F9.4)',err=902) tmax
	endif

	write(1,'(''Groups: '',i2)',err=902) NHIS
	write(1,'(''Channels: '',i4)',err=902) HISTLEN
	ress=real(res_pscnds)/1000000
	write(1,'(''Resolution: '',f8.4)',err=902) ress
	write(1,'(''Frames: '',i<dig(frames)>)',err=902) frames

	do ig=1,nhis
c calculate data sum, if sum=0 skip this group
	  sum=0 !integer sum of all data in this group
	  do ic=1,histlen
	    sum=sum+int(rdata(ig,ic))
	    enddo
	  if(sum.eq.0) goto 200

	  write(1,'()',err=902)
	  write(1,'(''Data: '',i2,'','',i4,'',GR'',i2.2)')ig,histlen,ig
	  ic=1	!channel to be written

c write all channels as formatted (space separated) integers, max 80 chars/line
 100	  continue	!begin a new output line
	  line=' '
	  il=1 !current write position in 'line'
 110	  continue	!add a channel
	  id=dig(int(rdata(ig,ic)))
	  if(il+id.gt.80) goto 150
	  write(line(il:il+id-1),'(i<id>)',err=903) int(rdata(ig,ic))
	  il=il+id+1
	  ic=ic+1
	  if(ic.gt.histlen) goto 150
	  goto 110
 150	  continue	!write line out
	  write(1,'(a<il-1>)',err=904) line(1:il-1)
	  if(ic.le.histlen) goto 100
	  write(1,'(''End: '',i<dig(sum)>)',err=902) sum
 200	  continue
	  enddo

c finally write out the magic last line
	write(1,'(''End_uSR:'')',err=902)

	close(1)
	type *,'Completed file',current
	files_done=files_done+1

c +++++++++ end of old format +++++++++
	else if (fform .eq.2) then
c table of histograms with header
c T0 from basetime.uda

c first the dead time correction?
c corrected numbers changed back to integers
c should be OK on runs with >1 Mevents since only the early bins with
c large counts are adjusted
	if(dtflag .eq.1) then
	  ress=real(res_pscnds)/1000000
	  do 2807 ig=1,nhis
	    igd=ig
	    if(ig .gt. ndt .and. rgmode) then
	      igd=igd-ndt
	    endif
            if (deadt(igd) .gt.0) then
              do 2507 ic=1,histlen
	       cor=1.0-deadt(igd)*float(rdata(ig,ic))/(float(frames)*ress)
               cordat=float(rdata(ig,ic))/cor
	       rdata(ig,ic)=int(cordat+0.5)
 2507	      continue
	    endif
 2807	  continue
	endif
c

        if (iname .eq. 'MUSR (DAE2)') then
	   write(fname,8002) lprefix, current
        else
	   write(fname,8001) current
	endif

8001	format('R',i5.5,'.DAT')
8002    format(a,i8.8,'.DAT')

	   open(1,file=fname,status='new',carriagecontrol='list',
     +     recl=999,recordtype='VARIABLE',
     +     defaultfile='usrdata.dat',err=901)

c write the run labels
	write(1,'(''Run: '',i<dig(nrun32)>,'' on '',A20)',err=902)
     *		 nrun32,iname
	if(llen(rtitle).gt.0) write(1,
	1 '(''Title: '',a10)',err=902) rtitle(1:10)
	if(llen(field).gt.0) write(1,
	1 '(''Field: '',a<llen(field)>)',err=902) field
	if(llen(setup).gt.0) write(1,
	1 '(''Setup: '',a<llen(setup)>)',err=902) setup
	if(llen(temp).gt.0) write(1,
	1 '(''Temp: '',a<llen(temp)>)',err=902) temp
	if(llen(date).gt.0) write(1,
	1 '(''Date: '',a<llen(date)>)',err=902) date

	if(t_ok) then
	  write(1,'(''TLOG Average: '',F9.4)',err=902) taverage
	  write(1,'(''TLOG RMS: '',F9.4)',err=902) trms
	  write(1,'(''TLOG Minimum: '',F9.4)',err=902) tmin
	  write(1,'(''TLOG Maximum: '',F9.4)',err=902) tmax
	endif

	write(1,'(''Groups: '',i2)',err=902) NHIS
	write(1,'(''Channels: '',i4)',err=902) HISTLEN
	write(1,'(''Frames: '',i<dig(frames)>)',err=902) frames
	write(1,*)'T0= ',t0,' us'
	if(dtflag) then
	  write(1,*)'Dead time correction from run ',dtsource
	  else
	  write(1,*)'Not corrected for dead times'
	endif

	max=0
	do 8005 i=1,histlen
	do 8005 j=1,nhis
	if (rdata(j,i) .gt. max) max=rdata(j,i)
8005	continue
	nsf=dig(max)+1
	if(nsf .lt.4) nsf=4

c	header line
	write(1,8008) (j,j=1,nhis)
8008	format (' Time  ',<nhis>(<nsf-3>(' '),'H',I2.2))

	do 8010 i=1,histlen
	t=real(res_pscnds)*(i-0.5)/1.0E6 - t0
	write(1,8009)t,(rdata(j,i),j=1,nhis)
8009	format (F7.3,<nhis>I<nsf>)
8010	continue
	close(1)
	type *,'Completed file',current
	files_done=files_done+1

	else
c +++++++++ asymmetry ++++++++++++
c (from RUMDA)
c T0 from basetime.uda file
c Groups from long.uda? fixed?
c Alpha from user (suggest value from long.uda)
c Dead time from dtpar.dat / dtepar.dat


	do 280 gp=1,nfgroups ! groups in file
	do 280 fb=1,2 ! forward then backward set

	do 239 ic=1,histlen
	  gsum(fb,ic,gp)=0.
239	continue

	do 280 i=1,nhg(fb,gp) ! histos within grp
        ig=hists(fb,i,gp)
	igd=ig
	if(ig .gt. ndt .and. rgmode) then
	  igd=igd-ndt
	endif
c
c correct counts and group histograms
c
	ress=real(res_pscnds)/1000000
        do 250 ic=1,histlen
        if (dtflag.eq.1 .and. deadt(igd) .gt.0) then
	  cor=1.0-deadt(igd)*float(rdata(ig,ic))/(float(frames)*ress)
          cordat=float(rdata(ig,ic))/cor
	else
	  cordat=rdata(ig,ic)
	endif

        gsum(fb,ic,gp)=gsum(fb,ic,gp)+cordat
 250    continue
 280    continue

        do 287 ic=1,histlen
        tim(ic)=((ic-0.5)*ress)-t0
 287    continue 
c
c
c	if ((rtitle(29:29).eq.'t').neqv.
c     *		(orient(1:1).eq.'T')) then
c	  write(*,*)'Warning: Data measured in wrong geometry?'
c	endif
        do 8501 ic=1,histlen
        if(tim(ic).lt.0) goto 8501
	do 8491 gp=1,nfgroups
        fsum=gsum(1,ic,gp)
        bsum=gsum(2,ic,gp)
        lnum=(fsum-alpha(gp)*bsum)
        lden=(fsum+alpha(gp)*bsum)
c        write(6,*)fsum,bsum,lnum,lden
	if(lden .gt.0) then
         rat=lnum/lden
         ee=(fsum+alpha(gp)*alpha(gp)*bsum)
         er2=ee*(1/(lden*lden))*(1 + rat*rat)
         ratl(ic,gp)=rat
         rate(ic,gp)=sqrt(er2)
	else ! no counts in F or B
	 ratl(ic,gp)=0.0
	 rate(ic,gp)=99.9 ! arbitrary?
	endif
8491	continue
8501	continue
c
        if (fform.eq.3) then
         if (iname .eq. 'MUSR (DAE2)') then
	   write(line,805) lprefix, current
         else
	   write(line,804) current
	 endif
        else
	  write(line,804) current
	endif

804	format('R',I5.5,'.DAT')
805    format(a,i8.8,'.DAT')

        open(3,file=line,status='new',defaultfile='tmp.lng',
     +		carriagecontrol='list',err=901)

c first the header
        if (fform.eq.3) then

	  write(3,'(''Run: '',i<dig(nrun32)>,'' on '',A20)',err=902)
     *		 nrun32,iname
	  if(llen(rtitle).gt.0) write(3,
	1 '(''Title: '',a10)',err=902) rtitle(1:10)
	  if(llen(field).gt.0) write(3,
	1 '(''Field: '',a<llen(field)>)',err=902) field
	  if(llen(setup).gt.0) write(3,
	1 '(''Setup: '',a<llen(setup)>)',err=902) setup
	  if(llen(temp).gt.0) write(3,
	1 '(''Temp: '',a<llen(temp)>)',err=902) temp
	  if(llen(date).gt.0) write(3,
	1 '(''Date: '',a<llen(date)>)',err=902) date

	  if(t_ok) then
	    write(3,'(''TLOG Average: '',F9.4)',err=902) taverage
	    write(3,'(''TLOG RMS: '',F9.4)',err=902) trms
	    write(3,'(''TLOG Minimum: '',F9.4)',err=902) tmin
	    write(3,'(''TLOG Maximum: '',F9.4)',err=902) tmax
	  endif

	  write(3,'(''Groups: '',i2)',err=902) NHIS
	  write(3,'(''Channels: '',i4)',err=902) HISTLEN
	  write(3,'(''Frames: '',i<dig(frames)>)',err=902) frames
	  write(3,*)'T0= ',t0,' us'
	  do 8041 gp=1,nfgroups
	  if(nfgroups.gt.1) then
	    write(3,*)'Group ',grpname(gp),':'
	  endif
	  write(3,444)'Forward histograms:',(hists(1,j,gp),j=1,nhg(1,gp))
	  write(3,444)'Backward histograms:',(hists(2,j,gp),j=1,nhg(2,gp))
	  write(3,*)'Alpha= ',alpha(gp)
8041	  continue
	  if(dtflag) then
	    write(3,*)'Dead time correction from run ',dtsource
	  else
	    write(3,*)'Not corrected for dead times'
	  endif


c now the data
c header line
858	  format(A8,8(A10,'Err       '))
	  write(3,858)'Time    ',(grpname(gp),gp=1,nfgroups)
        endif
        do 860 ic=1, histlen
        if(tim(ic).lt.0) goto 860
        write(3,859) tim(ic),(ratl(ic,gp),rate(ic,gp),gp=1,nfgroups)
859	format (F6.3,8(' ',F9.5,' ',F9.5))
  860   continue
        close(3)

c 
        

c
	type *,'Completed file',current
	files_done=files_done+1


c ++++++++++ end of new ++++++++++++++
	endif

	enddo!	current
9999	continue
	if(files_done .eq. (last_file-first_file+1)) then
	  type *,'Finished all files'
	else
	  write(*,*)'Finished, some files not converted'
	endif
	stop
 901	type *,'Cannot open file '//fname
	goto 9999
 902	close(1)
	type *,'Write error in '//fname
	goto 9999
 903	close(1)
	type *,'cannot write data to line'
	goto 9999
 904	close(1)
	type *,'Write error in '//fname
	type*,'cannot write line to file'
	goto 9999
900	type*,'Cannot open mcs file for run ',current
	type*,'It may need to be restored from the archive'
	goto 9999
910	type *,'Error reading mcs file info block:'//fname
	close(1)
	goto 9999
920	type *,'Error reading mcs file data:'//fname
	close(1)
	goto 9999
930	type *,'Unexpected END reading mcs file:'//fname
	close(1)
	goto 9999
940	type *,'To large mcs file, cannot read:'//fname
	close(1)
	goto 9999

	end
c-------------------------------------------------------------------

	options /nocheck
	integer function dig(i)
	implicit none
	integer i
	if(i.gt.99999999) then
	  dig=9
	else if(i.gt.9999999) then
	  dig=8
	else if(i.gt.999999) then
	  dig=7
	else if(i.gt.99999) then
	  dig=6
	else if(i.gt.9999) then
	  dig=5
	else if(i.gt.999) then
	  dig=4
	else if(i.gt.99) then
	  dig=3
	else if(i.gt.9) then
	  dig=2
	else
	  dig=1
	endif
	return
	end !dig

c-----------------------------------------------------

	integer function llen(s)
	implicit none
	character*(*) s
	integer i
	i=len(s)
10	if(i.eq.0.or.s(i:i).ne.' ') then
	   llen=i
	   return
	endif
	i=i-1
	goto 10
	end !llen


	CHARACTER*3 FUNCTION GET_BEAMLINE()
c
c	Allows selection of beamline, choosing a sensible default using an
c	algorithm given below.
c	Returns a three character string:
c	   'EMU' - for EMU beamline
c	   'MUS' - for MuSR beamline (old data)
c	   'USR' - for MuSR beamline (new data)
c
	INCLUDE '($LNMDEF)'
	INCLUDE '($JPIDEF)'

	STRUCTURE /ITEMLIST/
	   INTEGER*2 BUFLEN
	   INTEGER*2 ICODE
	   INTEGER*4 BUFADD
	   INTEGER*4 RETLENAD
	END STRUCTURE

	INTEGER LIB$GETJPI, SYS$TRNLNM

	INTEGER*2 BUFFER_LENGTH
	INTEGER STATUS, FLAG, LENGTH
	INTEGER SELECTED_BEAMLINE, DEFAULT_BEAMLINE
	CHARACTER*3 BUFFER_CONTENTS
	CHARACTER*10 USER, NODE
	CHARACTER*15 BEAM_PROMPT
	CHARACTER*80 FORMAT
	RECORD /ITEMLIST/ ITEMLIST(2)

c
c	Work out the default beamline in the following way:
c	   i) If the user id is 'EMU' or 'EMU01' select EMU beamline, etc.
c	  ii) If the node is 'EMU' select EMU beamline for any user, etc.
c	 iii) If the user has defined the logical:
c                'MUSR$BEAMLINE' to be 'EMU' select the EMU beamline
c                'MUSR$BEAMLINE' to be 'MUS' select the MuSR beamline (old data)
c                'MUSR$BEAMLINE' to be 'USR' select the MuSR beamline (new data)
c	      from any node, except if either of the first two conditions
c	      are satisfied.
c
	DEFAULT_BEAMLINE = 1

c	Find username, nodename and value of logical 'MUSR$BEAMLINE'
	STATUS = LIB$GETJPI(JPI$_USERNAME,,,, USER, LENGTH)
	STATUS = LIB$GETJPI(JPI$_NODENAME,,,, NODE, LENGTH)

	ITEMLIST(1).BUFLEN = 3
	ITEMLIST(1).ICODE = LNM$_STRING
	ITEMLIST(1).BUFADD = %LOC(BUFFER_CONTENTS)
	ITEMLIST(1).RETLENAD = %LOC(BUFFER_LENGTH)
	ITEMLIST(2).BUFLEN = 0
	ITEMLIST(2).ICODE = 0 
	FLAG = LNM$M_CASE_BLIND
	STATUS = SYS$TRNLNM(FLAG, 'LNM$PROCESS_TABLE',
     +  		    'MUSR$BEAMLINE',, ITEMLIST(1))

c	First check the logical and set according beamline
	IF (BUFFER_CONTENTS.EQ.'EMU') THEN
	   DEFAULT_BEAMLINE = 1
	ELSEIF (BUFFER_CONTENTS.EQ.'MUS') THEN
	   DEFAULT_BEAMLINE = 2
	ELSEIF (BUFFER_CONTENTS.EQ.'USR') THEN
	   DEFAULT_BEAMLINE = 3
	ENDIF

c	Now set beamline according to user and node, overiding logical
	IF ((USER.EQ.'EMU').OR.(USER.EQ.'EMU01').OR.
     +	    (NODE.EQ.'EMU')) THEN
	   DEFAULT_BEAMLINE = 1
	ELSEIF ((USER.EQ.'MUSR').OR.(USER.EQ.'MUSR01').OR.
     +	        (NODE.EQ.'MUSR')) THEN
	   DEFAULT_BEAMLINE = 3
	ELSEIF ((USER.EQ.'MUT').OR.(USER.EQ.'MUT01').OR.
     +	        (NODE.EQ.'MUT')) THEN
	   DEFAULT_BEAMLINE = 5
	ENDIF

100	TYPE *,' '
	TYPE *,'Select beamline from:'
	TYPE *,'     1. EMU'
	TYPE *,'     2. MuSR (old data sequence)'
	TYPE *,'     3. MuSR (new data sequence)'
	TYPE *,'     4. MuSR (DAE2 - NeXus)'
	TYPE *,'     5. ARGUS'
	TYPE *,'     6. MUT'
c	TYPE *,' '
1000	FORMAT('Beamline ['(I1)']: ')
	WRITE(BEAM_PROMPT, 1000) DEFAULT_BEAMLINE
	STATUS = LIB$GET_FOREIGN(FORMAT, BEAM_PROMPT)
	IF (FORMAT.EQ.' ') WRITE(FORMAT, '(I1)') DEFAULT_BEAMLINE
	READ(FORMAT,'(I1)', END=100, ERR=100) SELECTED_BEAMLINE
	IF ((SELECTED_BEAMLINE.LT.1).OR.
     +     (SELECTED_BEAMLINE.GT.6)) GOTO 100

	IF (SELECTED_BEAMLINE.EQ.1) THEN
	   GET_BEAMLINE = 'EMU'
	ELSEIF (SELECTED_BEAMLINE.EQ.2) THEN
	   GET_BEAMLINE = 'MUS'
	ELSEIF (SELECTED_BEAMLINE.EQ.3) THEN
	   GET_BEAMLINE = 'USR'
	ELSEIF (SELECTED_BEAMLINE.EQ.4) THEN
	   GET_BEAMLINE = 'MU2'
	ELSEIF (SELECTED_BEAMLINE.EQ.5) THEN
	   GET_BEAMLINE = 'ARG'
	ELSEIF (SELECTED_BEAMLINE.EQ.6) THEN
	   GET_BEAMLINE = 'MUT'
	ENDIF

	END
c
c
	subroutine TLOGGER (tlog_file,ok,average,RMS,ymin,ymax)
	logical ok
	real average,rms
	character*(*) tlog_file

c if file 'path' exists, returns OK=.TRUE. and sets average etc.
c
c	*************************************************
c
c
c       Reads data from the MCS TLOG files and plots on screen with
c       option of hardcopy.
c
c	Compile and link within MUT using the following:
c	   $ FORT/EXTEND TLOGGER
c          $ LINK TLOGGER,PGPLOT/OPT
c
c	Use '@MKTLOGGER' if available.
c
c
c       History:
c	Original program	S.D. Johnston
c
c	28/7/93			S.P. Cottrell
c		Complete revision allowing beamline selection and
c	        fixing the run number bug.
c
c	18/10/93		S.P. Cottrell
c		Graphics rewritten using PGPLOT.
c		RMS value calculated correctly.
c		Exit route provided.
c
c        9/12/93                 C.A Scott
c               Small changes to layout of plot, addition of PGPAGE
c 
c       10/07/94                 C.A Scott
c               More changes to layout of plot, inc. removal of PGPAGE
c               Addition of average and rms deviation to plot
c
c       14/03/95                 C.A Scott
c               Fix plot for case where all values are the same
c               Minimum window is now 10 mK
c
c	27/03/95                 S.P. Cottrell
c		Linked against PGPLOT5
c
c	18/04/95		 S.P. Cottrell
c		Added code to pick up restored files
c
c       30/12/95                 C.A  Scott
c               Reconstructed plotting to avoid COMMON block
c               
c	5/11/1996		J.S.Lord
c		Tries to read files from [data.musr.tlog] first (MTEMPLOG$)
c		then from [MUSR] 
c
c	3/12/1998		J.S. Lord
c		Includes MUT
c
c	22/5/2001		J.S. Lord
c		Converted to subroutine for inclusion in CONVERT_ASCII
c		Zero and Glitch detection disabled.
c
c	*************************************************
c
c
	INTEGER LIB$SPAWN, LIB$DELETE_FILE
	INTEGER LIB$SET_LOGICAL, LIB$GET_FOREIGN
c
	INTEGER READS, RUN
	REAL YMIN, YMAX
	REAL TEMP(5000), TIME(5000)
	CHARACTER*80 TITLE
c
	INTEGER STATUS, I, J, TERMINAL, LENGTH
	INTEGER WSTYPE, UNITS
	REAL XPOS, YPOS, DC_X, DC_Y, SCR_X, SCR_Y
	REAL INTERVAL, DIVIS
	REAL ELAPSED, JUNK2, JUNK3
	LOGICAL EXISTS, FIRST_PLOT
c
c
c
c	Select temperature log to plot
c
	TYPE *,' '
	TYPE *,'Searching for '//TLOG_FILE
	INQUIRE(FILE=TLOG_FILE,EXIST=EXISTS)
	IF (.NOT.EXISTS) THEN
	   TYPE *,' '
	   TYPE *,'%LOG-F-NOLOG no TLOG file present'
	   ok = .FALSE.
	   return
	ENDIF
c
c
c	open file & read data
c
	   OPEN(1,FILE=TLOG_FILE,ERR=900,FORM='FORMATTED',STATUS='OLD',
     +        READONLY)

	READ(1,'(A80)',END=910,ERR=920) TITLE
	READ(1,*,END=910,ERR=920) READS, INTERVAL
	READ(1,*,END=910,ERR=920) ELAPSED
	READ(1,*,END=910,ERR=920) JUNK2
	READ(1,*,END=910,ERR=920) JUNK3
	READ(1,'(A80)',END=910,ERR=920) FORMAT
	DO I=1,4998,7
	   READ(1,1030,END=120,ERR=910) (TEMP(I+J),J=0,6,1)
	ENDDO
120	CLOSE(1)
1030	FORMAT(7(1X,F10.3))
c
	if(reads.eq.0) goto 900 ! no data in log file
	YMIN = 1000
	YMAX = 0
	AVERAGE = 0.0
	DIVIS = 0.0
	DO I=1,READS
	   IF (YMIN.GT.TEMP(I)) YMIN = TEMP(I)
	   IF (YMAX.LT.TEMP(I)) YMAX = TEMP(I)
	   DIVIS = DIVIS + 1.0
	   AVERAGE = AVERAGE + TEMP(I)
	   TIME(I) = (INTERVAL * REAL(I)) / 60.0
	ENDDO
c
	AVERAGE = AVERAGE / DIVIS
	ELAPSED = ELAPSED / 60.0
c
	RMS = 0.0
	DO I=1,READS
	   RMS = RMS + ((AVERAGE - TEMP(I)) * (AVERAGE - TEMP(I)))
	ENDDO
	RMS = SQRT(RMS / DIVIS)
c
	TYPE *,' '
	WRITE(*,'('' Logging time           : '',F8.1,4X,''minutes'')') ELAPSED
	WRITE(*,'('' Average temp           : '',f8.3,'' Kelvin'')') AVERAGE
	WRITE(*,'('' RMS deviation          : '',f8.3,'' Kelvin'')') RMS
	WRITE(*,'('' Maximum temp           : '',f8.3,'' Kelvin'')') YMAX
	WRITE(*,'('' Minimum temp           : '',f8.3,'' Kelvin'')') YMIN
	TYPE *,' '
c
	ok = .true.
	return
c
c
900	continue
910	continue
920	continue
	ok = .false.
	return
	END
c
c
	subroutine NXTLOGGER (tlog_file,average,RMS,ymin,ymax)

	include 'muon_def.inc'

	real average,rms
	character*(*) tlog_file

	YMIN = 1000
	YMAX = 0
	AVERAGE = 0.0
	DIVIS = 0.0
	DO I=1,NXM_temp_log_available
           IF ((NXM_temp_log_time(I) .ge. 0.0) .and. (NXM_temp_log_values(I) .ne. 0.0)) then
	      IF (YMIN.GT.NXM_temp_log_values(I)) YMIN = NXM_temp_log_values(I)
	      IF (YMAX.LT.NXM_temp_log_values(I)) YMAX = NXM_temp_log_values(I)
	      DIVIS = DIVIS + 1.0
	      AVERAGE = AVERAGE + NXM_temp_log_values(I)
	   ENDIF
	ENDDO
c
	AVERAGE = AVERAGE / DIVIS                      
c
	RMS = 0.0
	DO I=1,NXM_temp_log_available
           IF ((NXM_temp_log_time(I) .ge. 0.0) .and. (NXM_temp_log_values(I) .ne. 0.0)) then
	      RMS = RMS + ((AVERAGE - NXM_temp_log_values(I)) * (AVERAGE - NXM_temp_log_values(I)))
           ENDIF
	ENDDO
	RMS = SQRT(RMS / DIVIS)

	tlog_file = 'Temperature log'

	return
	end
c 
c 
c------------------------------------------------------------------------------
c
