C******************************************************************************
C     Second moment calculation for triangular lattice
C     with inclusion of coherence length and 'Hc1' factor
C******************************************************************************
      parameter(ndim=1000)
      PARAMETER(isysinput=5,isysoutput=6,ifileout=10,
     +iparaminput=1,phio=2.067e-15)
      REAL B_field(ndim),delB(ndim),B_field_err(ndim),delB_err(ndim)
      REAL B1,B2,B3,Xi1,xi2,xi3,lambda,Tc
      CHARACTER*80 xaxis,yaxis,comment,title,yn
      common/moosymbols/linas,imar,pflag
      common/inpars/N,B1,B2,B3,T1,T2,T3,xi1,xi2,xi3,lambda,Tc,
     +iflag_1,iflag_2,iflag_3,iflag_4,iflag_5,numberX,nf

      call par_read(iparaminput)

      imar=0
      ifirst=0
      open(ifileout,file='coh3.out',status='unknown')
      icount=0

      if (iflag_4.eq.0) then
      xaxis=' Field (G)'
      yaxis=' Second moment (G^2)'
C     yaxis=' Sigma (us^-1)'
      else if (iflag_4.eq.1) then
      xaxis=' Temeprature (K)'
      yaxis=' Second moment (G^2)'
      endif

      do 80 coh=xi1,xi2,xi3
C for each value of coherence length
      icount=icount+1
       
  
      if (iflag_4.eq.0) then
      call second_mom_B(phio,B_field,delB,coh,npoints)
      else if (iflag_4.eq.1) then
      call second_mom_T(phio,B_field,delB,coh,npoints)
      endif

C write output........
      do 30 i=1,npoints
       if (iflag_2.eq.1) then
         write(isysoutput,*) B_field(i),delB(i),SQRT(delB(i)),lambda*1e10,coh*1e10 
       endif
      write(ifileout,*) B_field(i),SQRT(delB(i)) 
c      write(ifileout,*) B_field(i),SQRT(delB(i))*.060201
C bodge to give us-1 for UDA sigma!!!! 
30     continue

C  plot ......
      if (iflag_3.eq.1) then
      if (icount.eq.numberX) ifirst=2
      if (xi1.eq.xi2) ifirst=0
      if(ifirst.eq.0) then
      ifirst=3
      call mootpoint(B_field,delB,title,comment,xaxis,yaxis,npoints,
     +B_field_err,delB_err,xmin,xmax,ymin,ymax,ifirst)     
      ifirst=0
      endif
      xmin=0
      ymin=0
c      ymax=16000.
C      ymax=0.
      call mootpoint(B_field,delB,title,comment,xaxis,yaxis,npoints,
     +B_field_err,delB_err,xmin,xmax,ymin,ymax,ifirst)     
      if (xi1.eq.xi2) then 
      ifirst=2
      call mootpoint(B_field,delB,title,comment,xaxis,yaxis,npoints,
     +B_field_err,delB_err,xmin,xmax,ymin,ymax,ifirst)    
      endif 
      ifirst=1
      endif

80    continue      
      close(ifileout)
      end

C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      subroutine second_mom_T(phio,B_field,delB,coh,npoints)
      INTEGER N
      REAL lambda,lambda_T,coh,coh_T,B3,B1,B2,Tc,T1,T2,T3
      REAL B_field(*),delB(*)
      REAL n_fluid
      common/inpars/N,B1,B2,B3,T1,T2,T3,xi1,xi2,xi3,lambda,Tc,
     +iflag_1,iflag_2,iflag_3,iflag_4,iflag_5,numberX,nf
      ind=0     
      do 30 T=T1,T2,T3
      lambda_T=lambda*n_fluid(T,Tc,nf)
      coh_T=coh*n_fluid(T,Tc,nf)
      temp=n_fluid(T,Tc,nf)
      sum=second_moment(phio,B1,coh_T,lambda_T,N,iflag_1,iflag_5)
      ind=ind+1
      B_field(ind)=T
      if (T.le.Tc) then
      delB(ind)=sum*1e8
      else
      delB(ind)=0.
      endif
30    continue
      simp=0.003706*(phio*phio)/(lambda_T)**4
      npoints=ind
      return
      end
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      subroutine second_mom_B(phio,B_field,delB,coh,npoints)
      INTEGER N
      REAL lambda,lambda2,coh,coh2,B,B1,B2,d,KO,Tc,T1,T2,T3
      REAL B_field(*),delB(*)
      common/moosymbols/linas,imar,pflag
      common/inpars/N,B1,B2,B3,T1,T2,T3,xi1,xi2,xi3,lambda,Tc,
     +iflag_1,iflag_2,iflag_3,iflag_4,iflag_5,numberX,nf
      PI=4*ATAN(1.)
      ind=0     
      do 30 B=B1,B2,B3
      if (B.eq.0) goto 30
      sum=second_moment(phio,B,coh,lambda,N,iflag_1,iflag_5)
      ind=ind+1
      delB(ind)=sum*1e8
C second moment
C      delB(ind)=SQRT(sum)*1e-6*(2*pi*1.355e8)
C  PSI sigma in us-1
      B_field(ind)=B*1e4
30    continue
      npoints=ind
      simp=0.003706*(phio*phio)/(lambda)**4
      return
      end
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      subroutine par_read(iparaminput)
      REAL B1,B2,B3,Xi1,xi2,xi3,lambda,Tc,T1,T2,T3
      common/inpars/N,B1,B2,B3,T1,T2,T3,xi1,xi2,xi3,lambda,Tc,
     +iflag_1,iflag_2,iflag_3,iflag_4,iflag_5,numberX,nf

      open(iparaminput,file='coh3.dat',status='old')
      read(iparaminput,*) N
C number of summation terms in series
      read(iparaminput,*) B1,B2,numberB
      B1=B1*1e-4
      B2=B2*1e-4
      if (B1.eq.B2) then
      B3=B1
      else 
      B3=(B2-B1)/(NumberB-1)
      endif
      if (B1.eq.0.and.B2.eq.0) B3=1.
C convert from G to Tesla

      read(iparaminput,*) T1,T2,numberT
      if (T1.eq.T2) then
      T3=T1
      else 
      T3=(T2-T1)/(NumberT-1)
      endif
      if (T1.eq.0.and.T2.eq.0) B3=1.
C T-range to plot

      read(iparaminput,*) xi1,xi2,numberX
      xi1=xi1*1e-10
      xi2=xi2*1e-10
      if (xi1.eq.xi2) then
      xi3=xi1
      else 
      if (numberX.eq.1) numberX=2
      xi3=(xi2-xi1)/(numberX-1)
      endif
      if (xi1.eq.0.and.xi2.eq.0) xi3=1.
C convert form A to m 
      read(iparaminput,*) lambda
      lambda=lambda*1e-10
C convert form A to m 
      read(iparaminput,*) Tc
C Tc! can be 0 if iflag_4=0
      read(iparaminput,*) nf
C for nf th fluid model
      read(iparaminput,*) iflag_1
C determines whether have low field roll-off
C in the form factor iflag_1=1 means include it
      read(iparaminput,*) iflag_2
C determines whether write to screen iflag_1=1 means write
      read(iparaminput,*) iflag_3
C determines whether plot to screen iflag_2=1 means plot
      read(iparaminput,*) iflag_4
C determines whether plotting delB(B) =0 delB(T)=1
      read(iparaminput,*) iflag_5
C determines whether include the G-L reduced field factor
      close(iparaminput)
      return
       end
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C+++++++++++++++++++++++++++++++++++++++++++++++++++
      FUNCTION second_moment(phio,B,coh,lambda,N,iflag_1,iflag_5)
      REAL PI,sum,sum1,sum2
      INTEGER I,J,N
      REAL lambda,lambda2,coh,coh2,B,d,KO
      d=(SQRT(3.)/2)*(phio/B)
      d=SQRT(d)
c d-spacing for triangular lattice
      PI=4*ATAN(1.)
      prefact=(4*pi*pi/(d*d))
c mod k1 ^2- 1st order RLV
      lambda2=lambda*lambda
      coh2=coh*coh
      B_by_Bc2=iflag_5*B*2*pi*coh2/phio
C G-L expression for b=B/Bc2 using the coherence length
C if iflag_5=0 then this term is ignored
      B_by_Bc2=1-B_by_Bc2
      sum=0
      do 10 I=-N,N
         do 20 J=-N,N
           IF (I.eq.0.and.J.eq.0) goto 20
           sum1=I*I+J*I+J*J
           KO=prefact*sum1
           sum1=1/(KO*lambda2/(B_by_Bc2)+1*iflag_1)
C f(k)=1/(1+lambda^2k^2)
           sum1=sum1*exp(-KO*coh2/(2*B_by_Bc2))
           sum1=sum1*sum1*B*B
           sum=sum+sum1
20       continue
10    continue
      second_moment=sum
      return
      end
C+++++++++++++++++++++++++++++++++++++++++++++++++++
C+++++++++++++++++++++++++++++++++++++++++++++++++++
      REAL FUNCTION n_fluid(T,Tc,nf)
      REAL T,Tc
      INTEGER nf
      if (T.lt.Tc) then
      n_fluid=(T/Tc)**(nf)
      n_fluid=(1-n_fluid)**(0.5)
      n_fluid=1./n_fluid
      else
      n_fluid=100
C dummy argument
      endif
      return
      end
