      SUBROUTINE Magfield(PARS_IN,PARS_OUT)
C
C  To calculate the CONTRIBUTION TO NUCLEAR SIGMA from nuclei up to 2 unit
C  cells away.  Input is an ATOMS.atd file of atomic positions in unit cell
C
C  Units are SI throughout.
C
C  Function from Dalmas de Roetier's thesis - p II-34 (NOT SHENCK)
C
C
C


      IMPLICIT NONE
C
	external pars_in,pars_out

      DOUBLE PRECISION RECD,SUMREC,RES1,RES2,RES3,RES,SIG
      REAL X1(1100),Y1(1100),Z1(1100)
	REAL XPOS(20000),YPOS(20000),ZPOS(20000)
	REAL X1TMP(1100),Y1TMP(1100),Z1TMP(1100)
      REAL DIST1, DIST2, DIST3, DIST4
      REAL MUX, MUY, MUZ, SIGM, SIGMM, SIGMAX
	REAL XPOSMIN,YPOSMIN,ZPOSMIN, SIGMIN, realmux,realmuy,realmuz
      REAL LATTB,LATTC,B,C,LATTA,A, alpha,beta,gamma
	real f2cmat(3,3)
      INTEGER LOOP,COUNT,NX,NY,NZ,MX,MY,MZ,N,FLAG,I,NUM,E,typecount
	INTEGER numcount,firstnum(1000),scan,IPrRes,CountInt
      INTEGER SUBL, NUMTMP, savcount, savrec(100),j
      CHARACTER*255 FNAME, ATDFILENAME

      CHARACTER TITLE*80,CRAP*80,BALLS*80,RUBB*6
      CHARACTER*8 TYPE(1000),TYPEA(1000), TYPETMP(1000), seatype
      CHARACTER*1 ANS
	CHARACTER*255 TXT
	CHARACTER*255 readdata
	logical retlog, status, ScanX, ScanY, ScanZ, PrRes
	REAL*8 RESSIG(1030301) , RESMUX(1030301), RESMUY(1030301)
	REAL*8 RESMUZ(1030301)
!REAL*8 RESSIG(10000000), RESMUX(10000000), RESMUY(10000000), RESMUZ(10000000)
	INTEGER RESI
	REAL NI(100),GAM(100)
	INTEGER INDEX
	REAL MAGX(0:20000),MAGY(0:20000),MAGZ(0:20000)
	REAL*8 BX,BY,BZ,BMOD
C
C

	


      RESI=0
	COUNTINT=0
	SIGMIN=1E7

      CALL MODULE_GET_REAL(pars_in,'A',A)
	CALL MODULE_GET_REAL(pars_in,'B',B)
	CALL MODULE_GET_REAL(pars_in,'C',C)
	CALL MODULE_GET_REAL(pars_in,'alpha',alpha)
	CALL MODULE_GET_REAL(pars_in,'beta',beta)
	CALL MODULE_GET_REAL(pars_in,'gamma',gamma)
	
	CALL MODULE_GET_INT(pars_in,'flag',flag)
	

      IF (FLAG.EQ.1) THEN
	 CALL MODULE_GET_REAL(pars_in,'mux',mux)
	 CALL MODULE_GET_REAL(pars_in,'muy',muy)
	 CALL MODULE_GET_REAL(pars_in,'muz',muz)
	
	ENDIF

112   FORMAT(A1)
10    FORMAT(A60)
C
C
      LATTA=A
      LATTB=B
      LATTC=C

	CALL MODULE_GET_INT(pars_in,'IPrRes',IPrRes)
	IF (IPrRes.eq.1) THEN
	 PrRes=.TRUE.
	ELSE
	 PRRes=.FALSE.
	ENDIF
C
	CALL MODULE_GET_STRING(pars_in,'fname',fname)
      OPEN (UNIT=15,FILE=FNAME, RECL=512)

	CALL MODULE_GET_STRING(pars_in,'atdfilename',atdfilename)
	OPEN(UNIT=11,FILE=AtdFileName,STATUS='OLD')
		! Loads atomic positions
	DO I=1,1000
	 READ(11,*,IOSTAT=E)NUM,TYPE(I),X1(I),Y1(I),Z1(I),
     &                           MAGX(I),MAGY(I),MAGZ(I)

	 IF(E.LT.0) THEN
		NUM=I-1
		GO TO 146
	 END IF

	 WRITE(15,*) NUM,TYPE(I),X1(I),Y1(I),Z1(I),
     &                           MAGX(I),MAGY(I),MAGZ(I)
	END DO


146   CLOSE(11)



!      DO I=1,num
!	  WRITE(99,*) XPOS(i),YPOS(i),ZPOS(i)
!	ENDDO

	count=0
	DO i=1,num
			xpos(i)=x1(i)
			ypos(i)=y1(i)
			zpos(i)=z1(i)
		
	ENDDO

C
! ****************************************
51    FORMAT(A80)
56    FORMAT(4X,'Sublattice ',I4,' has ',I4,' atoms of type: ',A8)
60    FORMAT(2X,F5.2,2X,F5.2,2X,F5.2)
C
C Generate two unit cells in X,Y, and Z directions IN FIRST QUADRANT
C
	count=0
      DO NX=0,1
		DO NY=0,1
			DO NZ=0,1
				COUNT=COUNT+1
30				DO i=1,NUM
					CALL UNITGEN(Xpos,Ypos,Zpos,NUM,NX,NY,NZ,COUNT,i,						
     $ MAGX,MAGY,MAGZ)
				ENDDO
			END DO
		END DO
      END DO
!      WRITE(99,*) "After UnitGen"
 !     DO I=1,num*(count-1)+NUM
!	  WRITE(99,*) XPOS(i),YPOS(i),ZPOS(i)
!	ENDDO

C
C Copy first quadrant atoms onto other seven quadrants
C
	COUNT=0
      DO MX=0,2,2
	 DO MY=0,2,2
	    DO MZ=0,2,2
			COUNT=COUNT+1
			do i=1,num
				CALL QUADGEN(Xpos,Ypos,Zpos,NUM,MX,MY,MZ,COUNT,i,
     $MAGX,MAGY,MAGZ)
			enddo
	    END DO
	 END DO
      END DO
!
!
!      WRITE(99,*) "After QuadGen"
 !     DO I=1,NUM*8*(count-1)+NUM
!	  WRITE(99,*) XPOS(i),YPOS(i),ZPOS(i)
!	ENDDO


!	Call routine for create frac to cart matrix

	call getf2c(f2cmat, latta, lattb, lattc, alpha, beta, gamma)




C
C Calculate radii from muon location, and work out sigma
810   N=64*NUM
      SUMREC=0.0
      SIGMIN=10.0
      IF (FLAG.EQ.1) THEN
	    SUMREC=0.0
	    N=64*NUM
          call Magdepolcalc(latta,lattb,lattc,xPOS,yPOS,zPOS
     &               ,n,mux,muy,muz,f2cmat
     &				,realmux,realmuy,realmuz, bx,by,bz,bmod
     &                ,MAGX,MAGY,MAGZ)


	    
        WRITE(txt,11) MUX,MUY,MUZ,BX,BY,BZ,BMOD 
	    CALL MODULE_PRINT(txt)
	    write(15,*) MUX,MUY,MUZ,BX,BY,BZ,BMOD
	ELSE
C
C Get the scan direction and constant values..
	CALL MODULE_GET_INT(PARS_IN,"Scan",Scan)
      IF (Scan.eq.1) THEN
	 ScanX=.FALSE.
	 ScanY=.TRUE.
	 ScanZ=.TRUE.
	ELSEIF (Scan.eq.2) THEN
	 ScanX=.TRUE.
	 ScanY=.FALSE.
	 ScanZ=.TRUE.
	ELSEIF (Scan.eq.3) THEN
	 ScanX=.TRUE.
	 ScanY=.TRUE.
	 ScanZ=.FALSE.
	ELSEIF (Scan.eq.4) THEN
	 ScanX=.TRUE.
	 ScanY=.TRUE.
	 ScanZ=.TRUE.
	ENDIF
	 



	 IF (.not. ScanX) then
	  	 CALL MODULE_GET_REAL(pars_in,'mux',mux)
	 endif
	 IF (.not. ScanY) then
       	 CALL MODULE_GET_REAL(pars_in,'muy',muy)
	 endif
	 IF (.not. ScanZ) then
	 CALL MODULE_GET_REAL(pars_in,'muz',muz)
	 endif

       IF (ScanX.and.ScanY.and..not.ScanZ) then
	  Do MuX=0.00,1,0.01
	   Do MuY=0.00,1,0.01
	    SUMREC=0.0
	    N=64*NUM
          call Magdepolcalc(latta,lattb,lattc,xPOS,yPOS,zPOS
     &               ,n,mux,muy,muz,f2cmat
     &				,realmux,realmuy,realmuz, bx,by,bz,bmod
     &                ,MAGX,MAGY,MAGZ)



           IF (PrRes) THEN 

			WRITE(txt,11) MUX,MUY,MUZ,BX,BY,BZ,BMOD

			CALL MODULE_PRINT(txt)
	     else
	      countint=countint+1
	      IF(REAL(countint/10000)-real(countint)/10000.0.eq.0.0) THEN

			WRITE(txt,1972) 100.0*(REAL(countint)/1030301.0)
			CALL MODULE_PRINT(txt)
	      ENDIF
           ENDIF
	      WRITE(15,*)MUX,MUY,MUZ,BX,BY,BZ,BMOD

	    SUMREC=0.0
        END DO
	 ENDDO
	 ELSE IF (ScanY.and.ScanZ.and..not.ScanX) then
  	  Do MuY=0.00,1,0.01
	   Do MuZ=0.00,1,0.01
	    SUMREC=0.0
	    N=64*NUM
          call Magdepolcalc(latta,lattb,lattc,xPOS,yPOS,zPOS
     &               ,n,mux,muy,muz,f2cmat
     &				,realmux,realmuy,realmuz, bx,by,bz,bmod
     &                ,MAGX,MAGY,MAGZ)

           IF (PrRes) THEN 
			WRITE(txt,11) MUX,MUY,MUZ,BX,BY,BZ,BMOD
			CALL MODULE_PRINT(txt)
	     else
	      countint=countint+1
	      IF(REAL(countint/1000)-real(countint)/1000.0.eq.0.0) THEN
			WRITE(txt,1972) 100.0*(REAL(countint)/10201.0)
			CALL MODULE_PRINT(txt)

	      ENDIF
           ENDIF
	      WRITE(15,*)MUX,MUY,MUZ,BX,BY,BZ,BMOD
	    SUMREC=0.0
        END DO
	 ENDDO
	 ELSE IF (ScanX.and.ScanZ.and..not.ScanY) then
	  Do MuX=0.00,1,0.01
	   Do MuZ=0.00,1,0.01
	    SUMREC=0.0
	    N=64*NUM

          call Magdepolcalc(latta,lattb,lattc,xPOS,yPOS,zPOS
     &               ,n,mux,muy,muz,f2cmat
     &				,realmux,realmuy,realmuz, bx,by,bz,bmod
     &                ,MAGX,MAGY,MAGZ)

           IF (PrRes) THEN 
			WRITE(txt,11) MUX,MUY,MUZ,BX,BY,BZ,BMOD
			CALL MODULE_PRINT(txt)
	     else
	      countint=countint+1
	      IF(REAL(countint/1000)-real(countint)/1000.0.eq.0.0) THEN
			WRITE(txt,1972) 100.0*(REAL(countint)/10201.0)
			CALL MODULE_PRINT(txt)
	      ENDIF
           ENDIF
	      WRITE(15,*)MUX,MUY,MUZ,BX,BY,BZ,BMOD
	    SUMREC=0.0
         END DO
	  ENDDO
	 ELSEIF(ScanX.and.ScanY.and.ScanZ) then
	  Do MuX=0.00,1,0.01
         Do MuY=0.00,1,0.01
 	    Do MuZ=0.00,1,0.01
	     SUMREC=0.0
	     N=64*NUM
          call Magdepolcalc(latta,lattb,lattc,xPOS,yPOS,zPOS
     &               ,n,mux,muy,muz,f2cmat
     &				,realmux,realmuy,realmuz, bx,by,bz,bmod
     &                ,MAGX,MAGY,MAGZ)

           IF (PrRes) THEN 
			WRITE(txt,11) MUX,MUY,MUZ,BX,BY,BZ,BMOD
			CALL MODULE_PRINT(txt)
	     else
	      countint=countint+1
	      IF(REAL(countint/1000)-real(countint)/1000.0.eq.0.0) THEN
			WRITE(txt,1972) 100.0*(REAL(countint)/1030301.0)
			CALL MODULE_PRINT(txt)

	      ENDIF
           ENDIF
	      WRITE(15,*)MUX,MUY,MUZ,BX,BY,BZ,BMOD
	     SUMREC=0.0
		
	    ENDDO
         END DO
	  ENDDO
	
	!	WRITE(txt,11) SIGMIN,XPOSMIN,YPOSMIN,ZPOSMIN
	!		CALL MODULE_PRINT(txt)
	
	 ENDIF
	ENDIF
1972	FORMAT('% completed ',F5.1)
11    FORMAT(2X,'At (',F5.3,',',F5.3,',',F5.3,') the mag field is: Bx='
     & ,F5.1,' By=',F5.1,' Bz=',F5.1,' B=',F5.1,'.')
12    FORMAT(2X,F11.3,2X,F5.3,2X,F5.3,2X,F5.3)
13    FORMAT(2X,'New minimum, ',F11.3,'at (',F5.3,',',F5.3,',',F5.3,')')
      CLOSE(UNIT=15)
      END