***************************************************************************
C
      SUBROUTINE MagFieldCalc(MOM,DISTX,DISTY,DISTZ,DISTMOD,BX,BY,BZ)
C
      implicit none
      
      REAL MUOOPI,DISTX,DISTY,DISTZ,DIST1OR3,THETA,PHI,MOM,PI,DISTMOD
	REAL*8 BX,BY,BZ,BR,BTHETA
	CHARACTER*255 txt
C
      
C Muoopi is mu0 divided by 4pi
      MUOOPI=1E-7
      PI=4.0*ATAN(1.0)

	THETA=ACOS(DISTZ/DISTMOD)
	IF (THETA.LT.0.0) THEN
	 THETA=THETA+PI
	ENDIF

	IF (DISTX.GE.0.0.AND.DISTY.GE.0.0) THEN
	 IF (DISTX.EQ.0.0) THEN
	   PHI=PI/2.0
	 ELSE
 	   PHI=ATAN(DISTY/DISTX)
	 ENDIF
	ELSEIF (DISTX.LE.0.0.AND.DISTY.GE.0.0) THEN
	 IF (DISTY.EQ.0.0) THEN
	   PHI=PI
	 ELSE
 	   PHI=ATAN(ABS(DISTX)/DISTY)+PI/2.0
	 ENDIF
	ELSEIF (DISTX.LE.0.0.AND.DISTY.LE.0.0) THEN
	 IF (DISTX.EQ.0.0) THEN
	   PHI=1.5*PI
	 ELSE
 	   PHI=ATAN(ABS(DISTY)/ABS(DISTX))+PI
	 ENDIF
	ELSEIF (DISTX.GE.0.0.AND.DISTY.LE.0.0) THEN
	 IF (DISTY.EQ.0.0) THEN
	   PHI=0.0
	 ELSE
 	   PHI=ATAN(DISTX/ABS(DISTY))+1.5*PI
	 ENDIF
	ENDIF




      DIST1OR3=1.0/(DISTMOD**3.0)
	BR=MOM*2.0*COS(THETA)*DIST1OR3*1000.0
	BTHETA=MOM*SIN(THETA)*DIST1OR3*1000.0
!		First R component then theta component
!		Coords assume mag mom aligned along z

!	BX=BR*SIN(THETA)*COS(PHI)+BTHETA*SIN(PI/2.0-THETA)*COS(PHI)
!	BY=BR*SIN(THETA)*SIN(PHI)+BTHETA*SIN(PI/2.0-THETA)*SIN(PHI)
	IF (THETA.GE.0.0.AND.THETA.LT.(PI/2.0)) THEN
	 BZ=BR*COS(THETA)-BTHETA*COS(PI/2.0-THETA)
	 IF (PHI.GE.0.0.AND.PHI.LT.(PI/2.0)) THEN

	   BX=BR*SIN(THETA)*COS(PHI)
     $      +BTHETA*SIN(PI/2.0-THETA)*COS(PHI)

         BY=BR*SIN(THETA)*SIN(PHI)
     $      +BTHETA*SIN(PI/2.0-THETA)*SIN(PHI)

	 ELSEIF (PHI.GE.(PI/2.0).AND.PHI.LT.PI) THEN

	   BX=-BR*SIN(THETA)*SIN(PHI-(PI/2.0))
     $      -BTHETA*SIN(PI/2.0-THETA)*SIN(PHI-(PI/2.0))

         BY=BR*SIN(THETA)*COS(PHI-(PI/2.0))
     $      +BTHETA*SIN(PI/2.0-THETA)*COS(PHI-(PI/2.0))

	 ELSEIF (PHI.GE.PI.AND.PHI.LT.(1.5*PI)) THEN

	   BX=-BR*SIN(THETA)*COS(PHI-PI)
     $      -BTHETA*SIN(PI/2.0-THETA)*COS(PHI-PI)

         BY=-BR*SIN(THETA)*SIN(PHI-PI)
     $      -BTHETA*SIN(PI/2.0-THETA)*SIN(PHI-PI)

	 ELSEIF (PHI.GE.(1.5*PI).AND.PHI.LE.(2.0*PI)) THEN

	   BX=BR*SIN(THETA)*SIN(PHI-(1.5*PI))
     $      +BTHETA*SIN(PI/2.0-THETA)*SIN(PHI-(1.5*PI))

         BY=-BR*SIN(THETA)*COS(PHI-(1.5*PI))
     $      -BTHETA*SIN(PI/2.0-THETA)*COS(PHI-(1.5*PI))

	 ELSE
	   CALL MODULE_PRINT("Err Phi")
	 ENDIF
	ELSEIF (THETA.GE.(PI/2.0).AND.THETA.LE.PI) THEN
	 BZ=-BR*COS(PI-THETA)-BTHETA*COS(THETA-PI/2.0)

	 IF (PHI.GE.0.0.AND.PHI.LT.(PI/2.0)) THEN

	   BX=-BR*SIN(PI-THETA)*COS(PHI)
     $      -BTHETA*SIN(THETA-PI/2.0)*COS(PHI)

         BY=-BR*SIN(PI-THETA)*SIN(PHI)
     $      -BTHETA*SIN(THETA-PI/2.0)*SIN(PHI)

	 ELSEIF (PHI.GE.(PI/2.0).AND.PHI.LT.PI) THEN

	   BX=BR*SIN(PI-THETA)*SIN(PHI-(PI/2.0))
     $      +BTHETA*SIN(THETA-PI/2.0)*COS(PI-PHI)

         BY=-BR*SIN(PI-THETA)*COS(PHI-(PI/2.0))
     $      -BTHETA*SIN(THETA-PI/2.0)*SIN(PI-PHI)

	 ELSEIF (PHI.GE.PI.AND.PHI.LT.(1.5*PI)) THEN

	   BX=BR*SIN(PI-THETA)*COS(PHI-PI)
     $      +BTHETA*SIN(THETA-PI/2.0)*COS(PHI-PI)

         BY=BR*SIN(PI-THETA)*SIN(PHI-PI)
     $      +BTHETA*SIN(THETA-PI/2.0)*SIN(PHI-PI)

	 ELSEIF (PHI.GE.(1.5*PI).AND.PHI.LE.(2.0*PI)) THEN

	   BX=-BR*SIN(PI-THETA)*SIN(PHI-(1.5*PI))
     $      -BTHETA*SIN(THETA-PI/2.0)*COS(2.0*PI-PHI)

         BY=BR*SIN(PI-THETA)*COS(PHI-(1.5*PI))
     $      +BTHETA*SIN(THETA-PI/2.0)*SIN(2.0*PI-PHI)

       ELSE
	 	 CALL MODULE_PRINT("Err Phi")

       ENDIF
	ELSE
	 CALL MODULE_PRINT("Err Theta")
	ENDIF

C
      RETURN
      END
