      subroutine f2c(f2cmat,a,b,c,x,y,z)

!     convert fractional coordinate (a,b,c) to 

!     cartesian coordinate (x,y,z)

      real f2cmat(3,3)

      real a,b,c,x,y,z

      x=f2cmat(1,1)*a + f2cmat(1,2)*b + f2cmat(1,3)*c

      y=f2cmat(2,1)*a + f2cmat(2,2)*b + f2cmat(2,3)*c

      z=f2cmat(3,1)*a + f2cmat(3,2)*b + f2cmat(3,3)*c

      return

      end

      

      subroutine c2f(c2fmat,a,b,c,x,y,z)

!     convert cartesian coordinate (x,y,z) to

!     fractional coordinate (a,b,c)

      real c2fmat(3,3)

      real a,b,c,x,y,z

      a=c2fmat(1,1)*x + c2fmat(1,2)*y + c2fmat(1,3)*z

      b=c2fmat(2,1)*x + c2fmat(2,2)*y + c2fmat(2,3)*z

      c=c2fmat(3,1)*x + c2fmat(3,2)*y + c2fmat(3,3)*z

      return

      end

      

      subroutine getf2c(matrix,a,b,c,alfa,beta,gama)

      real matrix(3,3)

      real a, b, c, alfa, beta, gama

      real radeg, ca, cb, cg, sg, volu, zero

      data radeg, zero/1.7453292519943296d-2, 0.0d0/

!     this routine will create the conversion matrix for 

!     fractional to orthogonal coordinates as defined in 

!     the pdb manual (i.e. a along x)

      ca = cos(alfa*radeg)

      cb = cos(beta*radeg)

      cg = cos(gama*radeg)

      sg = sin(gama*radeg)

      volu = a*b*c*sqrt(1-ca*ca-cb*cb-cg*cg+2*ca*cb*cg)

      matrix(1,1) = sngl(a)

      matrix(2,1) = sngl(zero)

      matrix(3,1) = sngl(zero)

      matrix(1,2) = sngl(b*cg)

      matrix(2,2) = sngl(b*sg)

      matrix(3,2) = sngl(zero)

      matrix(1,3) = sngl(c*cb)

      matrix(2,3) = sngl(c*(ca-cb*cg)/sg)

      matrix(3,3) = sngl(volu/(a*b*sg))

      end subroutine getf2c

      

      subroutine gminv(a,b,n)

!

! inverts matrix a into matrix b.

! on entry a is a square nxn real matrix

! on exit  b is its inverse

!

      implicit real (a-h,o-z)

      integer         ii(500), il(500), ig(500)

      real         a(n,n), b(n,n)

      integer         i, j, is, k



! initialise b with values from a

      do i=1,n

       do j=1,n

        b(i,j)=a(i,j)

       enddo

      enddo

      d = 1.0

      is = n - 1

      do k = 1, n

        il(k) = 0

        ig(k) = k

      enddo

      do k = 1, n

        r = 0.0

        do 40 i = 1, n

          if (il(i) .ne. 0) goto 40

          w = b(i,k)

          x = abs(w)

          if (r .gt. x) goto 40

          r  = x

          p  = w

          kf = i

   40   continue

        ii(k) = kf

        il(kf) = kf

        d = d * p

        if (d .eq. 0.0) then

          print *,'whoops: d .eq. 0.0 in dgminv()'

          return

        endif

        do i = 1, n

          if (i .eq. kf) then

            b(i,k) = 1.0/p

          else

            b(i,k) = -b(i,k)/p

          endif

        enddo

        do 140 j = 1, n

          if (j .eq. k) goto 140

          w = b(kf,j)

          if (w .eq. 0.0) goto 140

          do  i = 1, n

            if (i .eq. kf) then

              b(i,j) = w/p

            else

              b(i,j) = b(i,j)+w*b(i,k)

            endif

          enddo

  140   continue

      enddo

      do k = 1, is

        kf = ii(k)

        kl = il(kf)

        kg = ig(k)

        if (kf .ne. kg) then

          do i = 1, n

            r = b(i,kf)

            b(i,kf) = b(i,kg)

            b(i,kg) = r

          enddo

          do j = 1, n

            r = b(k,j)

            b(k,j) = b(kl,j)

            b(kl,j) = r

          enddo

          il(kf) = k

          il(kg) = kl

          ig(kl) = ig(k)

          ig(k) = kf

          d = -d

        endif

      enddo

      end subroutine gminv

