      SUBROUTINE SIGMA(PARS_IN,PARS_OUT)
C
C  To calculate the CONTRIBUTION TO NUCLEAR SIGMA from nuclei up to 2 unit
C  cells away.  Input is an ATOMS.atd file of atomic positions in unit cell
C
C  Units are SI throughout.
C
C  Function from Dalmas de Roetier's thesis - p II-34 (NOT SHENCK)
C
C
C


      IMPLICIT NONE
C
	external pars_in,pars_out

      DOUBLE PRECISION RECD,SUMREC,RES1,RES2,RES3,RES,SIG
      REAL X1(1100),Y1(1100),Z1(1100)
	REAL XPOS(100,20000),YPOS(100,20000),ZPOS(100,20000)
	REAL X1TMP(1100),Y1TMP(1100),Z1TMP(1100)
      REAL DIST1, DIST2, DIST3, DIST4
      REAL MUX, MUY, MUZ, SIGM, SIGMM, SIGMAX
	REAL XPOSMIN,YPOSMIN,ZPOSMIN, SIGMIN, realmux,realmuy,realmuz
      REAL LATTB,LATTC,B,C,LATTA,A, alpha,beta,gamma
	real f2cmat(3,3)
      INTEGER LOOP,COUNT,NX,NY,NZ,MX,MY,MZ,N,FLAG,I,NUM,E,typecount
	INTEGER numcount,firstnum(1000),scan,IPrRes,CountInt
      INTEGER NUMA(0:100),SUBL, NumAt, NUMTMP, savcount, savrec(100),j
      CHARACTER*255 FNAME, ATDFILENAME

      CHARACTER TITLE*80,CRAP*80,BALLS*80,RUBB*6
      CHARACTER*8 TYPE(1000),TYPEA(1000), TYPETMP(1000), seatype
      CHARACTER*1 ANS
	CHARACTER*50 TXT
	CHARACTER*255 readdata
	logical retlog, status, ScanX, ScanY, ScanZ, PrRes
	REAL*8 RESSIG(1030301) , RESMUX(1030301), RESMUY(1030301)
	REAL*8 RESMUZ(1030301)
!REAL*8 RESSIG(10000000), RESMUX(10000000), RESMUY(10000000), RESMUZ(10000000)
	INTEGER RESI
	REAL NI(100),GAM(100)
	INTEGER INDEX
C
C
! Added for GUI

	


      RESI=0
	COUNTINT=0
	SIGMIN=1E7

      CALL MODULE_GET_REAL(pars_in,'A',A)
	CALL MODULE_GET_REAL(pars_in,'B',B)
	CALL MODULE_GET_REAL(pars_in,'C',C)
	CALL MODULE_GET_REAL(pars_in,'alpha',alpha)
	CALL MODULE_GET_REAL(pars_in,'beta',beta)
	CALL MODULE_GET_REAL(pars_in,'gamma',gamma)
	
	CALL MODULE_GET_INT(pars_in,'flag',flag)
	

      IF (FLAG.EQ.1) THEN
	 CALL MODULE_GET_REAL(pars_in,'mux',mux)
	 CALL MODULE_GET_REAL(pars_in,'muy',muy)
	 CALL MODULE_GET_REAL(pars_in,'muz',muz)
	
	ENDIF

112   FORMAT(A1)
10    FORMAT(A60)
C
C
      LATTA=A
      LATTB=B
      LATTC=C

	CALL MODULE_GET_INT(pars_in,'IPrRes',IPrRes)
	IF (IPrRes.eq.1) THEN
	 PrRes=.TRUE.
	ELSE
	 PRRes=.FALSE.
	ENDIF
C
	CALL MODULE_GET_STRING(pars_in,'fname',fname)
	CALL MODULE_GET_INT(pars_in,'INDEX',INDEX)
      OPEN (UNIT=15,FILE=FNAME, RECL=512)

	CALL MODULE_GET_STRING(pars_in,'atdfilename',atdfilename)
	IF (INDEX.EQ.1) THEN
	    OPEN(UNIT=11,FILE=AtdFileName,STATUS='OLD')
		READ(11,51) TITLE
		write(15,*) title
		DO I=1,9
			READ(11,51) CRAP
		END DO
55		FORMAT(2X,'There are ',I4, ' atoms in the unit cell.')
		DO I=1,1000
			READ(11,*,IOSTAT=E)NUM,TYPE(I),RUBB,X1(I),Y1(I),Z1(I)
			IF(E.LT.0) THEN
				NUM=I-1
				GO TO 145
			END IF

			WRITE(15,*) NUM,TYPE(I),RUBB,X1(I),Y1(I),Z1(I)

	    END DO
	ELSE IF (INDEX.EQ.2) THEN
		OPEN(UNIT=11,FILE=AtdFileName,STATUS='OLD')
		DO i=1,4
			READ(11,51) CRAP
		ENDDO
		! Loads atomic positions
		DO I=1,1000
			READ(11,*,IOSTAT=E)NUM,TYPE(I),X1(I),Y1(I),Z1(I)
			IF(E.LT.0) THEN
				NUM=I-1
				GO TO 146
			END IF

			WRITE(15,*) NUM,TYPE(I),RUBB,X1(I),Y1(I),Z1(I)
		END DO
! Need to sort the atomic positions in groups
146		NUMTmp=num
		numcount=1
		firstnum(1)=1
		DO I=1,NUM
			typetmp(i)=type(i)
			x1tmp(i)=x1(i)
			y1tmp(i)=y1(i)
			z1tmp(i)=z1(i)
			TYPECOUNT=0
! Finds out how many types and position of the first type...

			IF (I.GT.1) THEN
				DO j=I-1,1,-1
					IF (TYPETMP(i).EQ.TYPE(j)) THEN
						TYPECOUNT=1
					ENDIF
				ENDDO
				IF (TYPECOUNT.eq.0) THEN
					numcount=numcount+1
					firstnum(numcount)=i
				ENDIF
			ENDIF
		ENDDO
		count=0
	! Reorder
	    DO I=1,numcount
			seatype=typetmp(firstnum(i))
			DO J=1,NUM
				IF (TYPETMP(j).EQ.seatype) THEN
					count=count+1
					type(count)=typetmp(j)
					X1(count)=X1tmp(j)
					y1(count)=y1tmp(j)
					z1(count)=z1tmp(j)

				ENDIF
			ENDDO
		enddo

	ENDIF
      contiNUE

145   CLOSE(11)
      COUNT=1
	NUMA(0)=0
      DO I=2,NUM
	  IF(TYPE(I).NE.TYPE(I-1))THEN
	      NUMA(COUNT)=I-1-NUMA(COUNT-1)
	      TYPEA(COUNT)=TYPE(I-1)
	      COUNT=COUNT+1
	  END IF
      END DO
C
	IF (COUNT.Eq.1) THEN
		NUMA(COUNT)=NUM
	ELSEIF (COUNT.EQ.2) THEN
		NUMA(COUNT)=NUM-NUMA(COUNT-1)
	ELSEIF (COUNT.EQ.3) THEN
		NUMA(COUNT)=NUM-NUMA(COUNT-1)-numa(count-2)
	ENDIF
      TYPEA(COUNT)=TYPE(NUM)
C
      CALL MODULE_GET_INT(pars_in,'numat',numat)
      
! If Error in atom file and input number of atoms
	
	IF (numat.ne.count) then
	 CALL MODULE_PRINT("Error: num of atoms do not match ")
	 RETURN
      END IF

!     Opens and closes dialog for the input of gammas and Is
      CALL MODULE_GET_REAL_ARRAY(PARS_IN,"NI",NI,NumAt)
	CALL MODULE_GET_REAL_ARRAY(PARS_IN,"GAM",GAM,NumAt)



      SUBL=COUNT

	count=0
	DO i=1,num
		DO j=1,numa(i)
			count=count+1
			xpos(i,j)=x1(count)
			ypos(i,j)=y1(count)
			zpos(i,j)=z1(count)
		ENDDO
	ENDDO

C
! ****************************************
51    FORMAT(A80)
56    FORMAT(4X,'Sublattice ',I4,' has ',I4,' atoms of type: ',A8)
60    FORMAT(2X,F5.2,2X,F5.2,2X,F5.2)
C
C Generate two unit cells in X,Y, and Z directions IN FIRST QUADRANT
C
	count=0
      DO NX=0,1
		DO NY=0,1
			DO NZ=0,1
				COUNT=COUNT+1
30				DO i=1,NUMAT
					CALL UNITGEN(Xpos,Ypos,Zpos,NUMA,NX,NY,NZ,COUNT,i)						
				ENDDO
			END DO
		END DO
      END DO
      

C
C Copy first quadrant atoms onto other seven quadrants
C
	COUNT=0
      DO MX=0,2,2
	 DO MY=0,2,2
	    DO MZ=0,2,2
			COUNT=COUNT+1
			do i=1,numat
				CALL QUADGEN(Xpos,Ypos,Zpos,NUMA,MX,MY,MZ,COUNT,i)
			enddo
	    END DO
	 END DO
      END DO
!
!

!	Call routine for create frac to cart matrix

	call getf2c(f2cmat, latta, lattb, lattc, alpha, beta, gamma)




C
C Calculate radii from muon location, and work out sigma
810   N=64*NUMA(1)
      SUMREC=0.0
      SIGMIN=10.0
      IF (FLAG.EQ.1) THEN
	    SUMREC=0.0
	    N=64*NUMA(1)
          call depolcalc(latta,lattb,lattc,xpos,ypos,zpos
     &              ,n,gam,ni,mux,muy,muz,sig, numa, subl,numat,f2cmat
     &				,realmux,realmuy,realmuz)
         write(readdata,*) sig
	    
        WRITE(txt,11) SIG,MUX,MUY,MUZ	    
	    CALL MODULE_PRINT(txt)
	    write(15,*) txt
	ELSE
C
C Get the scan direction and constant values..
	CALL MODULE_GET_INT(PARS_IN,"Scan",Scan)
      IF (Scan.eq.1) THEN
	 ScanX=.FALSE.
	 ScanY=.TRUE.
	 ScanZ=.TRUE.
	ELSEIF (Scan.eq.2) THEN
	 ScanX=.TRUE.
	 ScanY=.FALSE.
	 ScanZ=.TRUE.
	ELSEIF (Scan.eq.3) THEN
	 ScanX=.TRUE.
	 ScanY=.TRUE.
	 ScanZ=.FALSE.
	ELSEIF (Scan.eq.4) THEN
	 ScanX=.TRUE.
	 ScanY=.TRUE.
	 ScanZ=.TRUE.
	ENDIF
	 



	 IF (.not. ScanX) then
	  	 CALL MODULE_GET_REAL(pars_in,'mux',mux)
	 endif
	 IF (.not. ScanY) then
       	 CALL MODULE_GET_REAL(pars_in,'muy',muy)
	 endif
	 IF (.not. ScanZ) then
	 CALL MODULE_GET_REAL(pars_in,'muz',muz)
	 endif

       IF (ScanX.and.ScanY.and..not.ScanZ) then
	  Do MuX=0.00,1,0.01
	   Do MuY=0.00,1,0.01
	    SUMREC=0.0
	    N=64*NUMA(1)
          call depolcalc(latta,lattb,lattc,xpos,ypos,zpos
     &           ,n,gam,ni,mux,muy,muz,sig, numa, subl,numat,f2cmat
     &				,realmux,realmuy,realmuz)


	    IF (SIG.LT.SIGMIN) THEN
	      SIGMIN=SIG
	    END IF

           IF (PrRes) THEN 

			WRITE(txt,11) SIG,MUX,MUY,MUZ

			CALL MODULE_PRINT(txt)
	     else
	      countint=countint+1
	      IF(REAL(countint/10000)-real(countint)/10000.0.eq.0.0) THEN

			WRITE(txt,1972) 100.0*(REAL(countint)/1030301.0)
			CALL MODULE_PRINT(txt)
	      ENDIF
           ENDIF
	      WRITE(15,*)SIG,MUX,MUY,MUZ,realmux,realmuy,realmuz
			resi=resi+1
			RESSIG(i)=sig
			RESMUX(i)=mux
			RESMUY(i)=muy
			RESMUZ(i)=muz

	    SUMREC=0.0
        END DO
	 ENDDO
	 ELSE IF (ScanY.and.ScanZ.and..not.ScanX) then
  	  Do MuY=0.00,1,0.01
	   Do MuZ=0.00,1,0.01
	    SUMREC=0.0
	    N=64*NUMA(1)
          call depolcalc(latta,lattb,lattc,xpos,ypos,zpos
     &              ,n,gam,ni,mux,muy,muz,sig, numa, subl,numat,f2cmat
     &				,realmux,realmuy,realmuz)

	    IF (SIG.LT.SIGMIN) THEN
	      SIGMIN=SIG
	    END IF
           IF (PrRes) THEN 
			WRITE(txt,11) SIG,MUX,MUY,MUZ
			CALL MODULE_PRINT(txt)
	     else
	      countint=countint+1
	      IF(REAL(countint/1000)-real(countint)/1000.0.eq.0.0) THEN
			WRITE(txt,1972) 100.0*(REAL(countint)/10201.0)
			CALL MODULE_PRINT(txt)

	      ENDIF
           ENDIF
	      WRITE(15,*)SIG,MUX,MUY,MUZ,realmux,realmuy,realmuz
			resi=resi+1
			RESSIG(i)=sig
			RESMUX(i)=mux
			RESMUY(i)=muy
			RESMUZ(i)=muz
	    SUMREC=0.0
        END DO
	 ENDDO
	 ELSE IF (ScanX.and.ScanZ.and..not.ScanY) then
	  Do MuX=0.00,1,0.01
	   Do MuZ=0.00,1,0.01
	    SUMREC=0.0
	    N=64*NUMA(1)

          call depolcalc(latta,lattb,lattc,xpos,ypos,zpos
     &              ,n,gam,ni,mux,muy,muz,sig, numa, subl,numat,f2cmat
     &				,realmux,realmuy,realmuz)

	    IF (SIG.LT.SIGMIN) THEN
	      SIGMIN=SIG
	    END IF
           IF (PrRes) THEN 
			WRITE(txt,11) SIG,MUX,MUY,MUZ
			CALL MODULE_PRINT(txt)
	     else
	      countint=countint+1
	      IF(REAL(countint/1000)-real(countint)/1000.0.eq.0.0) THEN
			WRITE(txt,1972) 100.0*(REAL(countint)/10201.0)
			CALL MODULE_PRINT(txt)
	      ENDIF
           ENDIF
	      WRITE(15,*)SIG,MUX,MUY,MUZ,realmux,realmuy,realmuz
			resi=resi+1
			RESSIG(i)=sig
			RESMUX(i)=mux
			RESMUY(i)=muy
			RESMUZ(i)=muz
	    SUMREC=0.0
         END DO
	  ENDDO
	 ELSEIF(ScanX.and.ScanY.and.ScanZ) then
	  Do MuX=0.00,1,0.01
         Do MuY=0.00,1,0.01
 	    Do MuZ=0.00,1,0.01
	     SUMREC=0.0
	     N=64*NUMA(1)
          call depolcalc(latta,lattb,lattc,xpos,ypos,zpos
     &               ,n,gam,ni,mux,muy,muz,sig, numa, subl,numat,f2cmat
     &				,realmux,realmuy,realmuz)

           IF (PrRes) THEN 
			WRITE(txt,11) SIG,MUX,MUY,MUZ
			CALL MODULE_PRINT(txt)
	     else
	      countint=countint+1
	      IF(REAL(countint/1000)-real(countint)/1000.0.eq.0.0) THEN
			WRITE(txt,1972) 100.0*(REAL(countint)/1030301.0)
			CALL MODULE_PRINT(txt)

	      ENDIF
           ENDIF
	      WRITE(15,*)SIG,MUX,MUY,MUZ,realmux,realmuy,realmuz
			resi=resi+1
			RESSIG(i)=sig
			RESMUX(i)=mux
			RESMUY(i)=muy
			RESMUZ(i)=muz
	     SUMREC=0.0
	    IF (SIG.LT.SIGMIN) THEN
	       SIGMIN=SIG
			XPOSMIN=MUX
			YPOSMIN=MUY
			ZPOSMIN=MUZ
	    END IF
		
	    ENDDO
         END DO
	  ENDDO
	
		WRITE(txt,11) SIGMIN,XPOSMIN,YPOSMIN,ZPOSMIN
			CALL MODULE_PRINT(txt)
	
	 ENDIF
	ENDIF
1972	FORMAT('% completed ',F5.0)
11    FORMAT(2X,'Sigma = ',F11.3,' at (',F5.3,',',F5.3,',',F5.3,')')
12    FORMAT(2X,F11.3,2X,F5.3,2X,F5.3,2X,F5.3)
13    FORMAT(2X,'New minimum, ',F11.3,'at (',F5.3,',',F5.3,',',F5.3,')')
      CLOSE(UNIT=15)
      END