      SUBROUTINE SIGMA_NEW(PARS_IN,PARS_OUT)
C
C  To calculate the CONTRIBUTION TO NUCLEAR SIGMA from nuclei up to 2 unit
C  cells away.  Input is an ATOMS.atd file of atomic positions in unit cell
C
C  Units are SI throughout.
C
C  Function from Dalmas de Roetier's thesis - p II-34 (NOT SHENCK)
C
C
C


      IMPLICIT NONE
C
	external pars_in,pars_out

      DOUBLE PRECISION RECD,SUMREC,RES1,RES2,RES3,RES,SIG
!      REAL X1(1100),Y1(1100),Z1(1100)
	REAL XPOS(20000),YPOS(20000),ZPOS(20000),NI(20000),GAM(20000)
!	REAL X1TMP(1100),Y1TMP(1100),Z1TMP(1100)
      REAL DIST1, DIST2, DIST3, DIST4
      REAL MUX, MUY, MUZ, SIGM, SIGMM, SIGMAX
	REAL XPOSMIN,YPOSMIN,ZPOSMIN, SIGMIN, realmux,realmuy,realmuz
      REAL LATTB,LATTC,B,C,LATTA,A, alpha,beta,gamma
	real f2cmat(3,3)
      INTEGER LOOP,COUNT,NX,NY,NZ,MX,MY,MZ,N,FLAG,I
	INTEGER numcount,firstnum(1000),scan,IPrRes,CountInt
      INTEGER NumAt,newNUMAT
      CHARACTER*255 FNAME, infname

      CHARACTER TITLE*80
 !     CHARACTER*8 TYPE(1000),TYPEA(1000), TYPETMP(1000), seatype
      CHARACTER*1 ANS
	CHARACTER*255 TXT
	CHARACTER*255 readdata
	logical retlog, status, ScanX, ScanY, ScanZ, PrRes
	INTEGER RESI
	INTEGER INDEX
C
C
! Added for GUI

	

      RESI=0
	COUNTINT=0
	SIGMIN=1E7

      CALL MODULE_GET_REAL(pars_in,'A',A)
	CALL MODULE_GET_REAL(pars_in,'B',B)
	CALL MODULE_GET_REAL(pars_in,'C',C)
	CALL MODULE_GET_REAL(pars_in,'alpha',alpha)
	CALL MODULE_GET_REAL(pars_in,'beta',beta)
	CALL MODULE_GET_REAL(pars_in,'gamma',gamma)
	
	CALL MODULE_GET_INT(pars_in,'flag',flag)
	

      IF (FLAG.EQ.1) THEN
	 CALL MODULE_GET_REAL(pars_in,'mux',mux)
	 CALL MODULE_GET_REAL(pars_in,'muy',muy)
	 CALL MODULE_GET_REAL(pars_in,'muz',muz)
	
	ENDIF

112   FORMAT(A1)
10    FORMAT(A60)
C
C
      LATTA=A
      LATTB=B
      LATTC=C

	CALL MODULE_GET_INT(pars_in,'IPrRes',IPrRes)
	IF (IPrRes.eq.1) THEN
	 PrRes=.TRUE.
	ELSE
	 PRRes=.FALSE.
	ENDIF
C
	CALL MODULE_GET_STRING(pars_in,'fname',fname)
	CALL MODULE_GET_STRING(pars_in,'infname',infname)
	CALL MODULE_GET_INT(pars_in,'INDEX',INDEX)
      OPEN (UNIT=15,FILE=FNAME, RECL=512)
	WRITE(15,*) TRIM(infname)

      CALL MODULE_GET_INT(pars_in,'numat',numat)
      
      CALL MODULE_GET_REAL_ARRAY(PARS_IN,"NI",NI,NumAt)
      CALL MODULE_GET_REAL_ARRAY(PARS_IN,"GAM",GAM,NumAt)
      CALL MODULE_GET_REAL_ARRAY(PARS_IN,"POSX",Xpos,NumAt)
      CALL MODULE_GET_REAL_ARRAY(PARS_IN,"POSY",Ypos,NumAt)
      CALL MODULE_GET_REAL_ARRAY(PARS_IN,"POSZ",Zpos,NumAt)

	count=0
	newnumat=0
      DO NX=0,1
	  DO NY=0,1
	    DO NZ=0,1
	      COUNT=COUNT+1
	      CALL UNITGEN(Xpos,Ypos,Zpos,NI,GAM,NX,NY,NZ,COUNT,NUMAT
     &,newnumat)						
	    END DO
	  END DO
      END DO
      NUMAT=newNUMAT
	newnumat=0


C
C Copy first quadrant atoms onto other seven quadrants
C
	COUNT=0
      DO MX=0,2,2
	 DO MY=0,2,2
	  DO MZ=0,2,2
	   COUNT=COUNT+1
	   CALL QUADGEN(Xpos,Ypos,Zpos,NI,GAM,MX,MY,MZ,COUNT,NUMAT
     &,newnumat)	
 	  END DO
	 END DO
      END DO
	NUMAT=newNUMAT

!
!

!	Call routine for create frac to cart matrix

	call getf2c(f2cmat, latta, lattb, lattc, alpha, beta, gamma)




C
C Calculate radii from muon location, and work out sigma

      SUMREC=0.0
      SIGMIN=10000000.0
	XPOSMIN=0.0
	YPOSMIN=0.0
	ZPOSMIN=0.0

      IF (FLAG.EQ.1) THEN
	    SUMREC=0.0
          call depolcalc(latta,lattb,lattc,xpos,ypos,zpos
     &              ,gam,ni,mux,muy,muz,sig,numat,f2cmat
     &				,realmux,realmuy,realmuz)
         write(readdata,*) sig
	    
        WRITE(txt,11) SIG,MUX,MUY,MUZ	    
	    CALL MODULE_PRINT(txt)
	    write(15,*) txt
	ELSE
C
C Get the scan direction and constant values..
	 CALL MODULE_GET_INT(PARS_IN,"Scan",Scan)

       IF (Scan.eq.1) THEN
	  ScanX=.FALSE.
	  ScanY=.TRUE.
	  ScanZ=.TRUE.
	 ELSEIF (Scan.eq.2) THEN
	  ScanX=.TRUE.
	  ScanY=.FALSE.
	  ScanZ=.TRUE.
	 ELSEIF (Scan.eq.3) THEN
	  ScanX=.TRUE.
	  ScanY=.TRUE.
	  ScanZ=.FALSE.
	 ELSEIF (Scan.eq.4) THEN
	  ScanX=.TRUE.
	  ScanY=.TRUE.
	  ScanZ=.TRUE.
	ENDIF
	 
	 IF (.not. ScanX) then
	  	 CALL MODULE_GET_REAL(pars_in,'ScanPos',mux)
	 endif
	 IF (.not. ScanY) then
       	 CALL MODULE_GET_REAL(pars_in,'ScanPos',muy)
	 endif
	 IF (.not. ScanZ) then
	 CALL MODULE_GET_REAL(pars_in,'ScanPos',muz)
	 endif

       IF (ScanX.and.ScanY.and..not.ScanZ) then
	  Do MuX=0.00,1,0.01
	   Do MuY=0.00,1,0.01
	    SUMREC=0.0
          call depolcalc(latta,lattb,lattc,xpos,ypos,zpos
     &              ,gam,ni,mux,muy,muz,sig,numat,f2cmat
     &				,realmux,realmuy,realmuz)


	    IF (SIG.LT.SIGMIN) THEN
	      SIGMIN=SIG
	    END IF

           IF (PrRes) THEN 

			WRITE(txt,11) SIG,MUX,MUY,MUZ

			CALL MODULE_PRINT(txt)
	     else
	      countint=countint+1
	      IF(REAL(countint/1000)-real(countint)/1000.0.eq.0.0) THEN

			WRITE(txt,1972) 100.0*(REAL(countint)/10201.0)
			CALL MODULE_PRINT(txt)
	      ENDIF
           ENDIF
	      WRITE(15,*)SIG,MUX,MUY,MUZ

	    SUMREC=0.0
        END DO
	 ENDDO
	 ELSE IF (ScanY.and.ScanZ.and..not.ScanX) then
  	  Do MuY=0.00,1,0.01
	   Do MuZ=0.00,1,0.01
	    SUMREC=0.0
          call depolcalc(latta,lattb,lattc,xpos,ypos,zpos
     &              ,gam,ni,mux,muy,muz,sig,numat,f2cmat
     &				,realmux,realmuy,realmuz)
	    IF (SIG.LT.SIGMIN) THEN
	      SIGMIN=SIG
	    END IF
           IF (PrRes) THEN 
			WRITE(txt,11) SIG,MUX,MUY,MUZ
			CALL MODULE_PRINT(txt)
	     else
	      countint=countint+1
	      IF(REAL(countint/1000)-real(countint)/1000.0.eq.0.0) THEN
			WRITE(txt,1972) 100.0*(REAL(countint)/10201.0)
			CALL MODULE_PRINT(txt)

	      ENDIF
           ENDIF
	      WRITE(15,*)SIG,MUX,MUY,MUZ
	    SUMREC=0.0
        END DO
	 ENDDO
	 ELSE IF (ScanX.and.ScanZ.and..not.ScanY) then
	  Do MuX=0.00,1,0.01
	   Do MuZ=0.00,1,0.01
	    SUMREC=0.0
	    call depolcalc(latta,lattb,lattc,xpos,ypos,zpos
     &              ,gam,ni,mux,muy,muz,sig,numat,f2cmat
     &				,realmux,realmuy,realmuz)

	    IF (SIG.LT.SIGMIN) THEN
	      SIGMIN=SIG
	    END IF
           IF (PrRes) THEN 
			WRITE(txt,11) SIG,MUX,MUY,MUZ
			CALL MODULE_PRINT(txt)
	     else
	      countint=countint+1
	      IF(REAL(countint/1000)-real(countint)/1000.0.eq.0.0) THEN
			WRITE(txt,1972) 100.0*(REAL(countint)/10201.0)
			CALL MODULE_PRINT(txt)
	      ENDIF
           ENDIF
	      WRITE(15,*)SIG,MUX,MUY,MUZ
	    SUMREC=0.0
         END DO
	  ENDDO
	 ELSEIF(ScanX.and.ScanY.and.ScanZ) then
	  Do MuX=0.00,1,0.01
         Do MuY=0.00,1,0.01
 	    Do MuZ=0.00,1,0.01
	     SUMREC=0.0
           call depolcalc(latta,lattb,lattc,xpos,ypos,zpos
     &              ,gam,ni,mux,muy,muz,sig,numat,f2cmat
     &				,realmux,realmuy,realmuz)
           IF (PrRes) THEN 
		   WRITE(txt,11) SIG,MUX,MUY,MUZ
	       CALL MODULE_PRINT(txt)
	     else
	       countint=countint+1
	       IF(REAL(countint/10000)-real(countint)/10000.0.eq.0.0) THEN
		 	 WRITE(txt,1972) 100.0*(REAL(countint)/1030301.0)
			 CALL MODULE_PRINT(txt)
	       ENDIF
           ENDIF
	      WRITE(15,*)SIG,MUX,MUY,MUZ,realmux,realmuy,realmuz
  	        SUMREC=0.0
	    IF (SIG.LT.SIGMIN) THEN
	       SIGMIN=SIG
		   XPOSMIN=MUX
		   YPOSMIN=MUY
		   ZPOSMIN=MUZ
	
	    END IF
	    ENDDO
         END DO
	  ENDDO
	  WRITE(txt,11) SIGMIN,XPOSMIN,YPOSMIN,ZPOSMIN
	  CALL MODULE_PRINT(txt)	
	 ENDIF
	ENDIF
1972	FORMAT('% completed ',F5.1)
11    FORMAT(2X,'Minimum Sigma = ',F11.3,' at (',F5.3,','
     +,F5.3,',',F5.3,')')
12    FORMAT(2X,F11.3,2X,F5.3,2X,F5.3,2X,F5.3)
13    FORMAT(2X,'New minimum, ',F11.3,'at (',F5.3,',',F5.3,',',F5.3,')')
      CLOSE(UNIT=15)
      END