C
C SIMULATION OF LONGITUDINAL MUSR DATA.
C FIELD DISTRIBUTION FROM A Crystal Structure
C
C DECLARATIONS
C
      subroutine ZSIMXTAL(PARS_IN,PARS_OUT)
      implicit none
	external pars_in,pars_out

	REAL PW,PW3,PW6,PWS
	REAL HW,HW3,HW6,HWS
	REAL GAM,PI,HPI,PIS,D,SIND3
	REAL TBW,TP,TD,TZ,T
	REAL HL,HX,HY,HZ,H,HXS,HYS,HZS,HS,HBW
	REAL MZ,COSSTHI,SINSTHI,COSWT
	REAL FPROB,BPROB
	REAL RFWD,RBCK,ASYM,E
	INTEGER I,TBIN,HBIN,F,B,COUNT,J,N
	INTEGER FWD(10000),BCK(10000),FLD(50000)
	CHARACTER*5 OUTFILE
	CHARACTER*10 DATFILE,LOGFILE,FLDFILE
	CHARACTER*28 txt
	CHARACTER*255 Xtalfilename
	real exponential2, GAUSS
	REAL X(100),Y(100),Z(100),MOM(100),XM,YM,ZM, LattA,LattB,LattC
	INTEGER NumAtoms, runno, bin, statusi
	REAL XPT(2000),YPT(2000),YERR(2000),TAU
        REAL XFLD(5000),YFLD(5000),YERRFLD(5000)


C
C
C INPUT DATA FROM SCREEN
C
C	WRITE(*,*) 'Enter the number of required events '
	call module_get_int(pars_in,'N',N)
C	WRITE(*,*) 'Enter the muon pulse width (micro secs) '
	call module_get_real(pars_in,'PW',PW)
C	WRITE(*,*) 'Enter the applied longitudinal field (Gauss) '
	call module_get_real(pars_in,'HL',HL)
C	WRITE(*,*) 'Enter the angle subtended by the detector (Rad) '
	call module_get_real(pars_in,'D',D)
C	WRITE(*,*) 'Enter the output filenumber (5 numbers max, no extention) '
	call module_get_int(pars_in,'RUNNO',RUNNO)
	call module_get_string(pars_in,'Xtalfilename',Xtalfilename)
	call module_get_real(pars_in,'XM',XM)
	call module_get_real(pars_in,'YM',YM)
	call module_get_real(pars_in,'ZM',ZM)
	WRITE(OUTFILE,5) RUNNO
		WRITE(99,*) OUTFILE
	WRITE(DATFILE,6) OUTFILE
	WRITE(LOGFILE,7) OUTFILE
	WRITE(FLDFILE,8) OUTFILE
5	FORMAT(I5)
6	FORMAT('R',A5,'.DAT')
7	FORMAT('R',A5,'.LOG')
8	FORMAT('F',A5,'.FLD')

C
C  Load the atoms file
C
	WRITE(99,*) XM,YM,ZM
        WRITE(99,*) N
        WRITE(99,*) PW
        WRITE(99,*) HL
        WRITE(99,*) D
        WRITE(99,*) RUNNO
        
        
        WRITE(99,*) Xtalfilename
        
	OPEN(10,file=Xtalfilename,status='old')
	READ(10,*) LattA,LattB,LattC
	read(10,*) Numatoms
	DO I=1,Numatoms
	 READ(10,*) X(I),Y(I),Z(I),MOM(I)
	ENDDO
	CLOSE(10)
	write(99,*) LattA,LattB,LattC,numatoms

C
C DEFINITIONS
C
      call system_clock(i)
	STATUSI=0
	i=(2*i)+1
      PI=4.0*ATAN(1.0)
      HPI=PI/2.0
	PIS=PI*PI
      GAM=2.0*PI*13.55342E-03
	TBW=0.016
	TZ=4.0
	SIND3=(SIN(D))/3.0
      PW3=3.0*PW
	PW6=6.0*PW
	PWS=PW*PW
      HW=5
	HBW=(SQRT(27.0)*HW)/1000
	COUNT=0
	TAU=2.19714
	DO j=1,2000
	 FWD(J)=0.0
	 BCK(J)=0.0
	 
	enddo

	DO j=1,5000
       FLD(J)=0.0
	ENDDO
C
C MAIN LOOP
C
C
C GENERATE MUON PULSE DISTRIBUTION
C
10	TP=GAUSS(I,PW6,PW3,PWS)
C
C GENERATE MUON LIFETIME DISTRIBUTION
C
20	TD=EXPONENTIAL2(I,TAU)
	IF (TD+TP.GT.28) THEN
	    GOTO 20
	ENDIF
C
C GENERATE FIELD DISTRIBUTION
C
C****************************************************************************
        CALL NUCLEARX(I,HXS,HYS,HZS,X,Y,Z,MOM,LATTA,LATTB,LATTC
     +                ,XM,YM,ZM,NUMATOMS,HL)
C****************************************************************************
C
	HS=(HXS+HYS+HZS)
	H=SQRT(HS)
C
C STORE FIELD DISTRIBUTION
C
	HBIN=JINT(H/HBW)+1
	IF (HBIN.LT.4999) FLD(HBIN)=FLD(HBIN)+1
C
C CALCULATE THE MUON SPIN Z COMPONENT
C
	COSSTHI=HZS/HS
	SINSTHI=1.0-COSSTHI
	COSWT=COS(H*GAM*TD)
	MZ=COSSTHI+SINSTHI*COSWT
C
C PROBABILITY OF DETECTING THE POSITRON
C
	FPROB=D/PIS*(D+MZ*SIND3)
	BPROB=D/PIS*(D-MZ*SIND3)
	TBIN=JINT((TD+TP+TZ)/TBW)
	F=JNINT(FPROB*10000)
	B=JNINT(BPROB*10000)
	FWD(TBIN)=FWD(TBIN)+F
	BCK(TBIN)=BCK(TBIN)+B
	COUNT=COUNT+F+B
      IF (COUNT.GT.STATUSI*1000000) then
	 WRITE(txt,1972) STATUSI*1000000
1972	 FORMAT('Muons Simulated ',I10)
         CALL MODULE_PRINT(txt)

	 STATUSI=STATUSI+1
	endif
C
C END OF MAIN LOOP
C
	IF (COUNT.LT.N) GOTO 10
C
C CALCULATE THE ASYMMETRY PLOT AND WRITE THE FILES
C
	OPEN(2,FILE=DATFILE)
	DO 30 J=1,2000
	T=REAL(J*TBW)-TZ
	IF (FWD(J).EQ.0.OR.BCK(J).EQ.0) THEN
       ASYM=0.0
	 E=0.0
	 WRITE(2,*) T,asym,E
	else
	 RFWD=REAL(FWD(J))
	 RBCK=REAL(BCK(J))
	 ASYM=(RFWD-RBCK)/(RFWD+RBCK)
	 E=SQRT(4.0*RFWD*RBCK*(RFWD+RBCK))/((RFWD+RBCK)**2.0)
	 WRITE(2,*) T,ASYM,E
	ENDIF
	xpt(j)=t
	ypt(j)=asym
	yerr(j)=e

30	CONTINUE
	CLOSE(2)
	OPEN(3,FILE=LOGFILE)
	WRITE(3,*) 'FILE = ',OUTFILE
	WRITE(3,*) 'COUNTS = ',COUNT
      WRITE(3,*) 'PULSE WIDTH = ',PW
	WRITE(3,*) 'FIELD WIDTH = ',HW
	WRITE(3,*) 'LNG FIELD = ',HL
	WRITE(3,*) 'DETECTOR ANGLE = ',D
	WRITE(3,*) 'CRYSTAL FILE = ', trim(XTALFILENAME)
	WRITE(3,*) 'MUON POSITION =',XM,YM,ZM
	WRITE(3,*) 'ATOM POS'
	DO I=1,NUMATOMS
	 WRITE(3,*) X(I),Y(I),Z(I),MOM(I)
	ENDDO
	CLOSE(3)
	OPEN(4,FILE=FLDFILE)
	DO 40 J=1,2000
	H=REAL((J-1)*HBW)
	E=SQRT(REAL(FLD(J)))
	WRITE(4,*) H,FLD(J),E
      if (e.eq.0.0) e=0.1
	XFLD(J)=H
	YFLD(J)=REAL(FLD(J))
	YERRFLD(J)=E
40	CONTINUE
	CLOSE(4)
	YFLD(1)=0.0
        CALL MODULE_PUT_REAL_ARRAY(PARS_OUT,"XFLD",XFLD,50000)
	CALL MODULE_PUT_REAL_ARRAY(PARS_OUT,"YFLD",YFLD,50000)
	CALL MODULE_PUT_REAL_ARRAY(PARS_OUT,"YERRFLD",YERRFLD,50000)
	CALL MODULE_PUT_REAL_ARRAY(PARS_OUT,"XPT",XPT,10000)
	CALL MODULE_PUT_REAL_ARRAY(PARS_OUT,"YPT",YPT,10000)
	CALL MODULE_PUT_REAL_ARRAY(PARS_OUT,"YERR",YERR,10000)

c
c Calling Plot routine
c


	END
C
C
c
C****************************************************************************
C
         SUBROUTINE NUCLEARX(I,HXS,HYS,HZS,X,Y,Z,MOM,LATTA,LATTB,LATTC,
     +                        XM,YM,ZM,num,HL)
C
c  THIS WILL GENERATE REAL NUCLEAR FIELDS FROM AN ACTUAL CRYSTAL STRUCTURE
C
c       this program will calculate the field distribution from a distribution
c       of nuclear moments around the muon
c
c
      implicit none
	real xm,ym,zm,x(100),y(100),z(100),dx,dy,dz,a,b,c,h,hnx,hny,hnz
	real size,pi,mom(100),SUM,dum,fac,bw,fx,sig,latta,lattb,lattc
	real r,r2,R3,rux,ruy,ruz,theta,thi,mux,muy,muz,cosdel,sindel
	REAL TUX,tuy,tuz,d,cosz,sinz,den, hxs,hys,hzs,HL
	INTEGER I,atom,num,hbin,field(-300:300),muon,loop
C
c
c       values of parameters
	pi=3.14159
C
C
	hnx=0
	hny=0
	hnz=0
C
c       must loop around all neighbours
	do 10 atom=1,num
C
c       calculate the x,y,z coordinates of of nucleas and muon
C
	dx=xm-x(atom)
	dy=ym-y(atom)
	dz=zm-z(atom)
	r2=(dx*dx)+(dy*dy)+(dz*dz)
	r=r2**0.5
	r3=r*r*r*latta*lattb*lattc
	rux=dx/r
	ruy=dy/r
	ruz=dz/r
C
C
c       pick position of spin direction and find unit vectors mux,muy,muz
C
33      dum=ran(I)*pi
	if (ran(I).gt.sin(dum)) then
	goto 33
	endif
	theta=dum
	thi=ran(I)*2.0*pi
	mux=sin(theta)*cos(thi)
	muy=sin(theta)*sin(thi)
	muz=cos(theta)
C
c       a,b and c are the components of mu cross ru
	a=ruy*muz-muy*ruz
	b=-(rux*muz-mux*ruz)
	c=rux*muy-mux*ruy
C
C
c       work out angle delt between mag vector m and vector r
c       dot product....JRS
	cosdel=(rux*mux)+(ruy*muy)+(ruz*muz)
c       don't see a need for the abs...JRS
	sindel=(abs(1-(cosdel*cosdel)))**.5
C
c       calculate the field in x,y,z dir from the radial part of the r vector
C
	fac=5.05*2.0*mom(atom)*cosdel/r3
C
c       THIS GIVES THE FIELD IN Gauss
c       since 5.05x10^-27J/T x10^-7Tm/A / 10^-30m^3 = 5.05e-4 T/10^4=5.05G
c       cf  J=Tm^2A therefore J/T=Am^2
C
	hnx=hnx+fac*rux
	hny=hny+fac*ruy
	hnz=hnz+fac*ruz
C
C       CALCULATE THE X COMPONENT OF THE UNIT TANGENTIAL VECTOR TO MUON
C       AND THE RESULTANT FIELD IN THE X DIRECTION FROM THIS COMPONENT
c
      IF(SINDEL.EQ.0.0) GO TO 10
	TUX=A/SINDEL
	TUY=B/SINDEL
	TUZ=C/SINDEL
	fac=5.05*mom(atom)*sindel/r3
	hnx=hnx+fac*tux
	hny=hny+fac*tuy
	hnz=hnz+fac*tuz
C
C       pick next nucleus
10      continue
C
	h=((hnx*hnx)+(hny*hny)+(hnz*hnz))**0.5
C
c       to do a polycrystalline average we need to rotate this field vector
c       first rotate around azimuthal with a prob of sin theta
C
	cosz=1-2*ran(i)
	sinz=(1-cosz*cosz)**0.5
	thi=ran(i)*2.0*pi
	hnx=h*sinz*cos(thi)
	hny=h*sinz*sin(thi)
      hnz=h*cosz+HL
      hxs=hnx*hnx
      hys=hny*hny
      hzs=hnz*hnz
C
        RETURN
        END
C
C FUNCTION TO GENERATE EXPONENTIAL PROBABILITY DISTRIBUTION
!
	FUNCTION EXPONENTIAL2(I,TAU)
	REAL X, exponential2,TAU
	INTEGER I
200     X=RAN(I)
        IF (X.EQ.0) THEN
          GOTO 200
        ELSE
          EXPONENTIAL2=-TAU*ALOG(1.0-X)
        ENDIF
	RETURN
	END


	FUNCTION GAUSS(I,W,M,WS)
	REAL GAUSS,W,M,WS,X,Y
	INTEGER I
100     X=RAN(I)*W
        Y=EXP(-0.5*(X-M)**2.0/WS)
        IF (RAN(I).LE.Y) THEN
          GAUSS=X-M
        ELSE
          GOTO 100
        ENDIF
	RETURN
	END
